
#include <ctype.h>
#include <inttypes.h>
#include <avr\pgmspace.h> //<--#include <progmem.h>
#include "Font.h"

/*
		bYPos++;
		wChScnLn=abs( (caBuff21[bCh] - 0x20) * 6 + bScan++); 	//!!Hier Increment bCh++ +  bScan++
		LCD_WriteData(bBl,gcaEngFont6x8[wChScnLn % LCDCHARROWSUM]);		
*/

// 0x20 = 32 Offset
// 0x7E = 126  ENde
const prog_char gpmaEngFont6x8[] PROGMEM = {
/* char 0x20 of width 6 at 0x2da */
'\x0',
'\x0',
'\x0',
'\x0',
'\x0',
'\x0',
/* char 0x21 of width 6 at 0x2ea */
'\x0',
'\x0',
'\x2f',
'\x0',
'\x0',
'\x0',
/* char 0x22 of width 6 at 0x2fa */
'\x0',
'\x3',
'\x0',
'\x3',
'\x0',
'\x0',
/* char 0x23 of width 6 at 0x30a */
'\x14',
'\x7f',
'\x14',
'\x7f',
'\x14',
'\x0',
/* char 0x24 of width 6 at 0x31a */
'\x24',
'\x2a',
'\x7f',
'\x2a',
'\x12',
'\x0',
/* char 0x25 of width 6 at 0x32a */
'\x63',
'\x13',
'\x8',
'\x64',
'\x63',
'\x0',
/* char 0x26 of width 6 at 0x33a */
'\x3a',
'\x45',
'\x4a',
'\x30',
'\x48',
'\x0',
/* char 0x27 of width 6 at 0x34a */
'\x0',
'\x0',
'\x3',
'\x0',
'\x0',
'\x0',
/* char 0x28 of width 6 at 0x35a */
'\x0',
'\x1c',
'\x22',
'\x41',
'\x0',
'\x0',
/* char 0x29 of width 6 at 0x36a */
'\x0',
'\x41',
'\x22',
'\x1c',
'\x0',
'\x0',
/* char 0x2a of width 6 at 0x37a */
'\x0',
'\x2a',
'\x1c',
'\x2a',
'\x0',
'\x0',
/* char 0x2b of width 6 at 0x38a */
'\x0',
'\x8',
'\x1c',
'\x8',
'\x0',
'\x0',
/* char 0x2c of width 6 at 0x39a */
'\x0',
'\x0',
'\xa0',
'\x60',
'\x0',
'\x0',
/* char 0x2d of width 6 at 0x3aa */
'\x0',
'\x8',
'\x8',
'\x8',
'\x0',
'\x0',
/* char 0x2e of width 6 at 0x3ba */
'\x0',
'\x0',
'\x40',
'\x0',
'\x0',
'\x0',
/* char 0x2f of width 6 at 0x3ca */
'\x60',
'\x10',
'\x8',
'\x4',
'\x3',
'\x0',
/* char 0x30 of width 6 at 0x3da */
'\x1c',
'\x22',
'\x41',
'\x22',
'\x1c',
'\x0',
/* char 0x31 of width 6 at 0x3ea */
'\x0',
'\x2',
'\x7f',
'\x0',
'\x0',
'\x0',
/* char 0x32 of width 6 at 0x3fa */
'\x62',
'\x51',
'\x49',
'\x45',
'\x42',
'\x0',
/* char 0x33 of width 6 at 0x40a */
'\x22',
'\x41',
'\x49',
'\x49',
'\x36',
'\x0',
/* char 0x34 of width 6 at 0x41a */
'\x18',
'\x14',
'\x12',
'\x7f',
'\x10',
'\x0',
/* char 0x35 of width 6 at 0x42a */
'\x2f',
'\x49',
'\x49',
'\x49',
'\x31',
'\x0',
/* char 0x36 of width 6 at 0x43a */
'\x3c',
'\x4a',
'\x49',
'\x48',
'\x30',
'\x0',
/* char 0x37 of width 6 at 0x44a */
'\x1',
'\x71',
'\x9',
'\x5',
'\x3',
'\x0',
/* char 0x38 of width 6 at 0x45a */
'\x36',
'\x49',
'\x49',
'\x49',
'\x36',
'\x0',
/* char 0x39 of width 6 at 0x46a */
'\x6',
'\x9',
'\x49',
'\x29',
'\x1e',
'\x0',
/* char 0x3a of width 6 at 0x47a */
'\x0',
'\x0',
'\x14',
'\x0',
'\x0',
'\x0',
/* char 0x3b of width 6 at 0x48a */
'\x0',
'\x20',
'\x14',
'\x0',
'\x0',
'\x0',
/* char 0x3c of width 6 at 0x49a */
'\x8',
'\x14',
'\x22',
'\x41',
'\x0',
'\x0',
/* char 0x3d of width 6 at 0x4aa */
'\x0',
'\x14',
'\x14',
'\x14',
'\x0',
'\x0',
/* char 0x3e of width 6 at 0x4ba */
'\x0',
'\x41',
'\x22',
'\x14',
'\x8',
'\x0',
/* char 0x3f of width 6 at 0x4ca */
'\x2',
'\x1',
'\x59',
'\x5',
'\x2',
'\x0',
/* char 0x40 of width 6 at 0x4da */
'\x3e',
'\x41',
'\x5d',
'\x55',
'\x1e',
'\x0',
/* char 0x41 of width 6 at 0x4ea */
'\x7e',
'\x9',
'\x9',
'\x9',
'\x7e',
'\x0',
/* char 0x42 of width 6 at 0x4fa */
'\x7f',
'\x49',
'\x49',
'\x49',
'\x36',
'\x0',
/* char 0x43 of width 6 at 0x50a */
'\x3e',
'\x41',
'\x41',
'\x41',
'\x22',
'\x0',
/* char 0x44 of width 6 at 0x51a */
'\x7f',
'\x41',
'\x41',
'\x41',
'\x3e',
'\x0',
/* char 0x45 of width 6 at 0x52a */
'\x7f',
'\x49',
'\x49',
'\x49',
'\x41',
'\x0',
/* char 0x46 of width 6 at 0x53a */
'\x7f',
'\x9',
'\x9',
'\x9',
'\x1',
'\x0',
/* char 0x47 of width 6 at 0x54a */
'\x3e',
'\x41',
'\x49',
'\x49',
'\x38',
'\x0',
/* char 0x48 of width 6 at 0x55a */
'\x7f',
'\x8',
'\x8',
'\x8',
'\x7f',
'\x0',
/* char 0x49 of width 6 at 0x56a */
'\x0',
'\x0',
'\x7f',
'\x0',
'\x0',
'\x0',
/* char 0x4a of width 6 at 0x57a */
'\x30',
'\x40',
'\x40',
'\x40',
'\x3f',
'\x0',
/* char 0x4b of width 6 at 0x58a */
'\x7f',
'\x8',
'\x4',
'\x1a',
'\x61',
'\x0',
/* char 0x4c of width 6 at 0x59a */
'\x7f',
'\x40',
'\x40',
'\x40',
'\x40',
'\x0',
/* char 0x4d of width 6 at 0x5aa */
'\x7f',
'\x2',
'\xc',
'\x2',
'\x7f',
'\x0',
/* char 0x4e of width 6 at 0x5ba */
'\x7f',
'\x6',
'\x8',
'\x30',
'\x7f',
'\x0',
/* char 0x4f of width 6 at 0x5ca */
'\x3e',
'\x41',
'\x41',
'\x41',
'\x3e',
'\x0',
/* char 0x50 of width 6 at 0x5da */
'\x7f',
'\x9',
'\x9',
'\x9',
'\x6',
'\x0',
/* char 0x51 of width 6 at 0x5ea */
'\x3e',
'\x41',
'\x51',
'\x21',
'\x5e',
'\x0',
/* char 0x52 of width 6 at 0x5fa */
'\x7f',
'\x9',
'\x9',
'\x19',
'\x66',
'\x0',
/* char 0x53 of width 6 at 0x60a */
'\x26',
'\x49',
'\x49',
'\x49',
'\x32',
'\x0',
/* char 0x54 of width 6 at 0x61a */
'\x1',
'\x1',
'\x7f',
'\x1',
'\x1',
'\x0',
/* char 0x55 of width 6 at 0x62a */
'\x3f',
'\x40',
'\x40',
'\x40',
'\x3f',
'\x0',
/* char 0x56 of width 6 at 0x63a */
'\x3',
'\x1c',
'\x60',
'\x1c',
'\x3',
'\x0',
/* char 0x57 of width 6 at 0x64a */
'\x3f',
'\x40',
'\x38',
'\x40',
'\x3f',
'\x0',
/* char 0x58 of width 6 at 0x65a */
'\x63',
'\x14',
'\x8',
'\x14',
'\x63',
'\x0',
/* char 0x59 of width 6 at 0x66a */
'\x3',
'\x4',
'\x78',
'\x4',
'\x3',
'\x0',
/* char 0x5a of width 6 at 0x67a */
'\x61',
'\x51',
'\x49',
'\x45',
'\x43',
'\x0',
/* char 0x5b of width 6 at 0x68a */
'\x0',
'\x7f',
'\x41',
'\x41',
'\x0',
'\x0',
/* char 0x5c of width 6 at 0x69a */
'\x3',
'\x4',
'\x8',
'\x10',
'\x60',
'\x0',
/* char 0x5d of width 6 at 0x6aa */
'\x0',
'\x41',
'\x41',
'\x7f',
'\x0',
'\x0',
/* char 0x5e of width 6 at 0x6ba */
'\x0',
'\x2',
'\x1',
'\x2',
'\x0',
'\x0',
/* char 0x5f of width 6 at 0x6ca */
'\x80',
'\x80',
'\x80',
'\x80',
'\x80',
'\x0',
/* char 0x60 of width 6 at 0x6da */
'\x0',
'\x1',
'\x2',
'\x4',
'\x0',
'\x0',
/* char 0x61 of width 6 at 0x6ea */
'\x38',
'\x44',
'\x44',
'\x24',
'\x78',
'\x0',
/* char 0x62 of width 6 at 0x6fa */
'\x7f',
'\x44',
'\x44',
'\x44',
'\x38',
'\x0',
/* char 0x63 of width 6 at 0x70a */
'\x38',
'\x44',
'\x44',
'\x44',
'\x28',
'\x0',
/* char 0x64 of width 6 at 0x71a */
'\x38',
'\x44',
'\x44',
'\x44',
'\x7f',
'\x0',
/* char 0x65 of width 6 at 0x72a */
'\x38',
'\x54',
'\x54',
'\x54',
'\x18',
'\x0',
/* char 0x66 of width 6 at 0x73a */
'\x0',
'\x4',
'\x7e',
'\x5',
'\x0',
'\x0',
/* char 0x67 of width 6 at 0x74a */
'\x98',
'\xa4',
'\xa4',
'\xa4',
'\x7c',
'\x0',
/* char 0x68 of width 6 at 0x75a */
'\x7f',
'\x4',
'\x4',
'\x4',
'\x78',
'\x0',
/* char 0x69 of width 6 at 0x76a */
'\x0',
'\x0',
'\x7d',
'\x0',
'\x0',
'\x0',
/* char 0x6a of width 6 at 0x77a */
'\x0',
'\x40',
'\x80',
'\x7d',
'\x0',
'\x0',
/* char 0x6b of width 6 at 0x78a */
'\x7f',
'\x8',
'\x18',
'\x24',
'\x44',
'\x0',
/* char 0x6c of width 6 at 0x79a */
'\x0',
'\x1',
'\x3e',
'\x40',
'\x0',
'\x0',
/* char 0x6d of width 6 at 0x7aa */
'\x7c',
'\x4',
'\x78',
'\x4',
'\x78',
'\x0',
/* char 0x6e of width 6 at 0x7ba */
'\x7c',
'\x4',
'\x4',
'\x4',
'\x78',
'\x0',
/* char 0x6f of width 6 at 0x7ca */
'\x38',
'\x44',
'\x44',
'\x44',
'\x38',
'\x0',
/* char 0x70 of width 6 at 0x7da */
'\xfc',
'\x24',
'\x24',
'\x24',
'\x18',
'\x0',
/* char 0x71 of width 6 at 0x7ea */
'\x18',
'\x24',
'\x24',
'\x24',
'\xfc',
'\x0',
/* char 0x72 of width 6 at 0x7fa */
'\x7c',
'\x8',
'\x4',
'\x4',
'\x4',
'\x0',
/* char 0x73 of width 6 at 0x80a */
'\x48',
'\x54',
'\x54',
'\x54',
'\x24',
'\x0',
/* char 0x74 of width 6 at 0x81a */
'\x0',
'\x4',
'\x3f',
'\x44',
'\x0',
'\x0',
/* char 0x75 of width 6 at 0x82a */
'\x3c',
'\x40',
'\x40',
'\x40',
'\x7c',
'\x0',
/* char 0x76 of width 6 at 0x83a */
'\xc',
'\x30',
'\x40',
'\x30',
'\xc',
'\x0',
/* char 0x77 of width 6 at 0x84a */
'\x3c',
'\x40',
'\x38',
'\x40',
'\x3c',
'\x0',
/* char 0x78 of width 6 at 0x85a */
'\x44',
'\x28',
'\x10',
'\x28',
'\x44',
'\x0',
/* char 0x79 of width 6 at 0x86a */
'\x9c',
'\xa0',
'\xa0',
'\xa0',
'\x7c',
'\x0',
/* char 0x7a of width 6 at 0x87a */
'\x44',
'\x64',
'\x54',
'\x4c',
'\x44',
'\x0',
/* char 0x7b of width 6 at 0x88a */
'\x0',
'\x8',
'\x36',
'\x41',
'\x0',
'\x0',
/* char 0x7c of width 6 at 0x89a */
'\x0',
'\x0',
'\x7f',
'\x0',
'\x0',
'\x0',
/* char 0x7d of width 6 at 0x8aa */
'\x0',
'\x41',
'\x36',
'\x8',
'\x0',
'\x0',
/* char 0x7e of width 6 at 0x8ba */
'\x2',
'\x1',
'\x2',
'\x1',
'\x0',
'\x0'
};
