

#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER


#define UART_USE_ENABLED
//#define ADC_USED_ENABLED

//PORT_ASSIGMNEMTS
#define WDTO_2S   7 //WatchDog
//SOFTWARE USED DEFINES

//CHECK PUD = PULLUPDISSABLE in SFIOR 
#define DISABLE_ALL_PULLUP()	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL()	(SFIOR &= ~(_BV(PUD)));
// 1.main.c einstellungen

#define TICK_1000MS 977


#define ROW_SIZE 10
#define COL_SIZE 12 

#define BLOCK1_DDRC 0x0F
#define BLOCK2_DDRD 0xF0
#define BLOCK3_DDRB 0x03

#define VAL_PORTC_MSK 0x000F
#define VAL_PORTD_MSK 0x00F0

#define PORTB_MSK 		0x03
#define VAL_PORTB_MSK 	0x0300

extern uint16_t gu16aROW[ROW_SIZE];

//#define SERVO_8BIT_L_OFFSET_MIN	24 
//#define SERVO_8BIT_RECHTS_MAX	36 



#define TICK_EVENT 				 0x01
#define UART_RX_EVENT			 0x02
#define STATUS_TRIGGER_OUTPUT	 0x04
#define LISSAJOUS	0x08
#define APFEL		0x12
//uint8_t gu8Status;

extern double dX_Min;;
extern double dX_Max;
extern double dY_Min;
extern double dY_Max;
extern uint16_t u16IterartionMax;

extern volatile uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
extern uint8_t gu8Status;
#endif  //MAIN_HEADER

