
#ifndef MAX543_DAC_HEADER
#define MAX543_DAC_HEADER
	
#define MAX543PORTX		PORTC
#define MAX543DIRREG	DDRC

//Stelle die verwendeten Bits selbst ein 
#define MAX543CLK_BIT		_BV(1)
#define MAX543SRI_BIT		_BV(2)
#define MAX543LOAD_BIT		_BV(3)
#define MAX543_CTRL_MASK	(MAX543CLK_BIT | MAX543SRI_BIT | MAX543LOAD_BIT)

#define MAX543_INITDIR()  (MAX543DIRREG |=  MAX543_CTRL_MASK) //DDRC |= 0b00011100

#define MAX543_SRI_HIGH()		(MAX543PORTX |= MAX543SRI_BIT);
#define MAX543_SRI_LOW()		(MAX543PORTX &= ~MAX543SRI_BIT);

#define MAX543_CLK_HIGH() 		(MAX543PORTX |= MAX543CLK_BIT);
#define MAX543_CLK_LOW()		(MAX543PORTX &= ~MAX543CLK_BIT);

#define MAX543_LOAD_HIGH()		(MAX543PORTX |= MAX543LOAD_BIT);	
#define MAX543_LOAD_LOW()		(MAX543PORTX &= ~MAX543LOAD_BIT);

#define AUFLOESUNG_SINUS 4096 //0...4095
extern void MAX543(uint16_t u16Val);

#endif //MAX543_DAC_HEADER