

#include <stdint.h> 
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>

#include "MAX543.h"

void MAX543(uint16_t u16Val)
{
uint8_t u8NN = 11;
MAX543_INITDIR();
MAX543_CLK_LOW(); //Startcondition
MAX543_LOAD_HIGH(); //Startcondition
do
	{
	if(	u16Val & (1 << u8NN) )
		{
		MAX543_SRI_HIGH();
		}
	else
		{
		MAX543_SRI_LOW();
		}
		MAX543_CLK_HIGH();
 	_delay_us(1); 
	//__asm__ __volatile__( "rjmp 1f\n 1:" );    // 2 cycles
	if( !u8NN ) // u8NN == 0
		{
		MAX543_LOAD_LOW();
		};
		MAX543_CLK_LOW();
	}while(u8NN--);	
_delay_us(1); 
//__asm__ __volatile__( "rjmp 1f\n 1:" );    // 2 cycles
MAX543_LOAD_HIGH() 
};
