
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"SOS-Blinki  interne LED"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"16.03.2017 12:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <math.h>


uint8_t gu8Sinus[56];

// ************************
void InitSinusArray( void )
// ************************
{
uint8_t u8NN=0;
for( u8NN=0; u8NN < 56; u8NN++ )
	{
	gu8Sinus[u8NN] = 28 + 28*sin(2* M_PI* u8NN/56.0);
	}
};

// *******************
int main(void)
// *******************
{

uint8_t u8NN=0;
DDRC  = 0x3F;
InitSinusArray();

while(1)  // endless loop
	{
	PORTC = gu8Sinus[u8NN];
	u8NN++;
	u8NN %= 56;
//	_delay_ms( 50 );
	};	//while

};	//main
// *** MAIN END ***
