
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"SOS-Blinki  interne LED"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"16.03.2017 12:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>


#define T_PUNKT 		200
#define T_STRICH 		600
#define T_LUECKE		150
#define T_ZEICHEN_ABSTAND 1000
#define T_WORT_ABSTAND	1500

// LED AN  BIT 5 -->  7,6,5,4,3,2,1,0
#define LED_BIT 32	//0b00100000   // Siehe Schaltplan 


void TX_3Zeichen(unsigned int u16OnTime)
{
	PORTB = LED_BIT;
	_delay_ms( u16OnTime );
	PORTB = 0;
	_delay_ms( T_LUECKE );
	
	PORTB = LED_BIT;
	_delay_ms( u16OnTime );
	PORTB = 0;
	_delay_ms( T_LUECKE );
	
	PORTB = LED_BIT;
	_delay_ms( u16OnTime );
	PORTB = 0;

	_delay_ms( T_ZEICHEN_ABSTAND );
};


// *******************
int main(void)
// *******************
{
DDRB  = LED_BIT;	//Direction Register
while(1)  // endless loop
	{
	TX_3Zeichen( T_PUNKT );
	TX_3Zeichen( T_STRICH );
	TX_3Zeichen( T_PUNKT );
	_delay_ms( T_WORT_ABSTAND );
	};	//while

};	//main
// *** MAIN END ***
