

#include <stdint.h> 
#include <avr/sfr_defs.h>
#include <avr\io.h>

#include "MixedPortByte"

void MixedPortByteInit(void)
{
Bit0_5_DDRX |= Bit0_5_MSK;
Bit6_7_DDRX |= Bit6_7_MSK;
};

void MixedPortByte( uint8_t u8Byte )
{
Bit0_5_PORT = (Bit0_5_PORT & ~ Bit0_5_MSK) | (u8Byte & Bit0_5_MSK);
Bit6_7_PORT = (Bit6_7_PORT & ~ Bit6_7_MSK) | (u8Byte & Bit6_7_MSK);
};

/*
Vorstellbar sind auch Verschiebeoperatoren:  Bsp. 
PORTx = ((u8Byte & Bit6_7_MSK) >> 6);  // legt 6..7 an PortBit 0..1
*/
