

#include <stdint.h> 
#include <avr\interrupt.h>
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>

#ifdef __cplusplus
extern "C" {
#endif

#include "debug.h"

#ifdef __cplusplus
}
#endif

//WORD Anzeige in Binaerer Form
#ifdef WORD_TO_BIN_USED
// *******************************************************************
char * WordToBin(uint16_t u16Word)
// *******************************************************************
{
static char ucBin[18]; // Array  zeigt Lcke 0000 0000
char * pcParser = ucBin;
uint8_t u8NN=15;

do
{
if(u8NN == 7)
	{*pcParser =' '; pcParser++;}; // Fge Lcke ein im BYTE
if(u16Word & (1<<u8NN) )
	{
	*pcParser = '1';
	}
else
	{
	*pcParser = '0';
	};
pcParser++;
}while(u8NN--);
ucBin[17]=0;
return  ucBin;
};
#endif


//Byte Anzeige in Binaerer Form
#ifdef BYTE_TO_BIN_USED
// *******************************************************************
char * ByteToBin(uint8_t u8Byte)
// *******************************************************************
{
static char ucBin[9]; //groesse 8+1
char * pcParser = ucBin;
uint8_t u8NN=7;
do
{
if( u8Byte & (1 << u8NN) )
	{
	*pcParser = '1';
	}
else
	{
	*pcParser = '0';
	};
pcParser++;
}while(u8NN--);
ucBin[8]=0; //Terminierung
return  ucBin;
};
#endif 

//mit Oszilloscope Testpin am Controller an geeigneter Steelle watchen.
// Zahl der Toggles gibt Position an. 
#ifdef  TOGGLE_FLAG_USED
// ****************************************************************
void Toggle_Bit(uint8_t u8Cnt)
// ****************************************************************
{ // #include <util\delay.h>  muss da sein
//cli();
//unsigned char u8NN;
TOGGLE_DIRREG |= (1 << TOGGLE_BIT);
while(u8Cnt--)
	{
	TOGGLE_PORT |= (1 << TOGGLE_BIT);
	_delay_us(1);
//	for(u8NN=10;u8NN;u8NN--){}; // 10 =250NS
	TOGGLE_PORT &= ~(1 << TOGGLE_BIT);
	//for(u8NN=10;u8NN;u8NN--){};
	_delay_us(1);
	};
//sei();
};
#endif