
#ifndef DEBOUNCE_1SW_HEADER
	#define  DEBOUNCE_1SW_HEADER


//HARDWARE
#define TASTER_DDRX			DDRB
#define TASTER_PINX			PINB
#define TASTER_PULLUP_PORTX	PORTB
#define TASTER_BIT 		(1<< PORTB0) //oder mehrere Bits

//MAKRO
#define  TASTER_INIT_INPUT()	(TASTER_DDRX &= ~TASTER_BIT) 
#define  TASTER_PULLUP()		(TASTER_PULLUP_PORTX |= TASTER_BIT)
#define  TASTER_GEDRUECKT()		(!(TASTER_PINX & TASTER_BIT)) //TRUE wenn gedrckt

// DEFINE SECTION --> main.h
#define PRESSED_DETECT		0x01
#define RELEASED			0x02
#define RELEASE_DETECT		0x04
#define RELEASED_SONDER_JOB	0x08
#define SWITCH_VALID		0x10
#define SWITCH_INTERRUPT_EVENT	0x80
//gu8SWFlag

#define READ_SWITCH_MAX   20
#define RELEASE_COUNT_MIN 200

extern void Debounce( void ); // momentan nur EINE Taste
extern uint8_t gu8SWFlag;	
#endif // DEBOUNCE_1SW
 