

/*
To DOs
NACH ENTFERNEN Der BATTERIE WATCH Widestnde ist ein PullU ~10K gen V+ einzuten
der ASURO FLASH Software "mault" Batterie ist LOW....

Pollswitch testen

http://www.roboterclub-freiburg.de/projekte/asuro/index.php
http://www.chakotay.de/c-kurs/html/kap_3.htm
*/


/*
in gu8PWM_D11_Val   steht der Wert fr die IR-SENSOR Position
in gu8StateMachine steht die Aktion die Gerade durchgefhrt wird.
*/

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
//SYSINFO
#define HARDWARE	"ATMega8+ASURO"
#define DATUM		"30.10.2014 14:00"
#define SOFTWARE	"ASURO Mnemonic AVATAR mit ODO"
#define AUTOR		"* Christof Ermer *"
#define IHAVENOBRAIN	"I have no brain."	
#define USEYOURS		"Use your own"
#define BAUDRATE	"2400,8,N,1"

/*
FUSES ATMEGA 8 ohne Bootloader
LOW =	DE
HIGH = 	CF
*/
/*
Dies IST DAS AVATAR ASURO Programm

NEU
Vorhaben
Einfhrung  einfachere Move Befehle

29.09.2014
PWM an D112
IR-Sensor an ADC5
ADC Routine erweitert mit  REFERENCE einstellung
REF fr IR Sensor = 2,56Volt
ADC Average Routine dazugefgt


FUSE
http://www.engbedded.com/fusecalc/
HFUSE = CF
LFUSE = 8F
BODEN 2, 8V CKOP, Watchdog

FILE POSITION 
C:\AVR_Projekte\AA_AVR_PRJ_2014\AT8_Asuro-Avatar+Orgs-22.08.2014

22.08.2014
BESONDERHEITEN 
Das Orginal asuro.c ist modifiziert .. Nicht verwecheln
deshalb heisst es myasuro.c myasuro.h

Die entsprechenen Positionen haben 
// =/CE\=
als Zeichen
*/
/*
BESONDERHEITEN und eingefhrt

gu32_Ticks = 282 //TICK_PER_SECOND 282
wird vom 72KHz Interrupt alle /256 hochgezhlt
in ISR(SIG_OUTPUT_COMPARE2) 
	modulo UART_TXRX_Check();  

*/


/*
Alles von Arrex zum Asuro
http://www.arexx.nl/arexx.php?cmd=goto&cparam=p_asuro_downloads
FUSE SETTING FOR BOOLOADER  8MHZ Quarz

LOW FUSE 0xFF
HIGH FUSE 0xC9   // ohne BOOTRST
dies nicht //HIGH FUSE 0xC8   // mit Hacken=\/  BOOTRST

LOCK-WRITE 0xFF	//ALLES OFFEN  , mit eXtreme Burner
-->Dies NACH BootLoader Upload anwenden: 
 LOCK-WRITE 0xCF	//SPERRT BOOTBEREICH mit eXtreme Burner gelesen.

( Mit Pony Bootbereich schtzen )
BootLock11   Hcken = 0 Machen
BootLock12 Hcken = 0 Machen
BOOT-Z1,Z0=00  mit Hacken=\/ = default Value




http://www.mikrocontroller.net/articles/AVR_Bootloader_in_C_-_eine_einfache_Anleitung
BOOTLOADER 1024 words
Start ADRESS $0C00   --> geladen auf 0x1C00

Achtung: Es muss darauf geachtet werden, 
dass beim flashen der Anwendung 
nicht der Bootloader berschrieben wird.
Bei Verwendung von avrdude muss dazu die 
Option "-D" angegeben werden 
(Flash-Speicher nicht automatisch lschen).

http://www.asurowiki.de/pmwiki/pmwiki.php/Main/Bootloader
http://www.alvidi.de/data_sheets/bootloader.pdf
*/

// PWM IMMER AKTIVE


#include <stdint.h> 
#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

//#include <stdio.h>
//#include <math.h>
#include <stdlib.h>
//#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <util\delay.h>

//#include "avr_register.h"	//with Hardware assigns
#include "main.h"			//with Hardware assigns
#include "uart.h"
#include "myasuro.h"
#include "Befehle.h"
#include "statmach.h"
#include "debug.h"
#ifdef MAX7219_USED
	#include "max7219.h"
#endif


//#include "rc5.h"


// GLOBALE VARIABLEN 

//const char MCA_DELIMITER[] PROGMEM	= ",";

volatile unsigned long gu32_Ticks; //  T2 timeCounter //extern bekannt gemacht
volatile unsigned long gu32BlinkTime; //extern bekannt gemacht
volatile uint32_t gu32IRSenseChk; // Tick compare

volatile unsigned char gu8ProgModeFlag; //Prog Mode Flags
volatile unsigned char gu8TxFlag; //tx Monitor Mode Flags
volatile uint8_t gu8SwitchValue; // lokale vergleiche




#ifdef MAX7219_USED
//unsigned char gu8MatrixRow;
unsigned char gu8MatrixCData;
unsigned int gu16MaxValue;
#endif


//Prototypen


//void (*bootloader)( void ) = 0x0C00U;  // Achtung Falle: Hier Word-Adresse
/*
// ****************************************************************
ISR(INT1_vect )
// *******************************************************************
{ // TASTER
GICR &= ~(1 << INT1);
MotorSpeed(0,0);
gu8StateMachine = SM_SWITCH_EVENT;
};
*/

/*
// PRESCALER 3,6864 /  32 = 115200 50-200Khz gewnscht
// REM ADC4-ADC5 = 8 BIT;
// 4+2 Channel. 
*/

#ifdef INT0_USED // ON RED LED
// ****************************************************************
ISR( INT0_vect ) // Metallsucher
// *******************************************************************
{ // TASTER
//GICR &= ~(1 << INT0);
gsMetallSuch.u16_MetallPulsINT0Cnt++;
//gsGeigerCnt.u32Int0_TimeStamp = gu32_Ticks;
};
#endif


#ifdef INT1_USED // on Switch
// ****************************************************************
ISR( INT1_vect ) //Radioaktive Detect  SCHALTER  1K OHM ABKLEMMEN
// *******************************************************************
{ // TASTER
//GICR &= ~(1 << INT1);
gsGeigerCnt.u16GeigerINT1_Cnt++;
//gsGeigerCnt.u32Int0_TimeStamp = gu32_Ticks;
};
#endif



#ifdef IR_DISTANCE_USED
// *****************
uint16_t GetIR_Sens(void)
// *****************
{
//return  ADC_Average( IR_SENSOR_ADC | ADC_INTERN_BANDGAP_2_56V );
return ADC_AT8_10Bit( IR_SENSOR_ADC | ADC_5V_AN_C );
};
#endif


// **************************
uint8_t Abweichung(int32_t i32Val1,int32_t i32Val2, uint16_t u16Difference)
// **************************
{ // Return True wenn  unterschied erfllt.
if( labs( i32Val1 - i32Val2 ) > u16Difference) // labs? //stdlib.h
	{
	return 1;
	}
else
	{
	return 0;
	};	
};



#ifdef STEPHAN_FIRMWARE_USED
// *******************************
void WriteMatrixChar( PGM_P pgmgChar )
// *******************************
{ 
uint8_t u8NN;
uint8_t u8CC;
MAX7219_Clear();
MAX7219_SetBrightness( 0xF );
for(u8NN=0; u8NN < 8; u8NN++)
	{
	u8CC = pgm_read_byte_near( pgmgChar + u8NN );
	MAX7219_Write(u8NN+1, u8CC);
	};
};


// *******************************
void RestoreMatrix( void )
// *******************************
{
uint8_t u8NN;
MAX7219_Clear();
for(u8NN=1; u8NN < 9; u8NN++)
	{
	MAX7219_SetBrightness( 2 );
	MAX7219_Write(u8NN, ~( 255U << gsGeigerCnt.u16GeigerCntAverage[u8NN-1]) );
	};
};
	

// *******************************
void ClearGeigerArray( void)
// *******************************
{
int8_t u8NN;
//MAX7219_Clear();
for(u8NN=0; u8NN < 8; u8NN++)
	{
	gsGeigerCnt.u16GeigerCntAverage[u8NN] = 0;
	};
};
#endif


// *******************************************************************
int main(void)
// *******************************************************************
{
volatile static uint32_t u32Now;
volatile static uint32_t u32BlinkTick;
//uint8_t u8Misc;  // Alllerweltsflags fr Tests

//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//Wichtige Schritte.. so bald wie mglich
//SFIOR = (1<<PUD); //Pullup Disable
//wdt_disable();
//DISABLE_ALL_PULLUP();

//ASURO !!!!!!!!
Init(); // ASURO

uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );
ResetRxBuff();
sei();

uart_puts_p( PSTR( SOFTWARE ) );uart_putc(13);
uart_puts_p( PSTR( HARDWARE ));uart_putc(13); 
uart_puts_p( PSTR( DATUM )  );uart_putc(13); 
uart_puts_p( PSTR( AUTOR ) );uart_putc(13); 
uart_puts_p( PSTR( IHAVENOBRAIN ) );uart_putc(13); 
uart_puts_p( PSTR( USEYOURS ) );uart_putc(13); 


//strcpy_P( gcaStr, PSTR("??") );  //Zeige beim Start das Men an
//CheckOrder( gcaStr );
//  START SETTINGS
gu32BlinkTime = TICK_500MS;  //extern bekannt gemacht
#ifdef PWM_ON_D11_USED
gu8PWM_D11_Val = PWM_MITTE;
_delay_ms(50);
#endif

//gu8StateMachine = STATE_SCHWENKE_DAS_IR_RADAR; //STATEMACH_NIX;
gu8StateMachine = STATE_MACH_NIX; //0; //STATE_MACH_NIX;


ResetRxBuff();

wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();   //WATCHDOG!

gu16IR_Sensibility = IR_ZUNAHE;


#ifdef GEIGERZAEHLER_USED
GEIGER_INIT1();
GEIGER_INIT2();
gsGeigerCnt.i16GeigerAktivitaetsFakor = TICK_1000MS;
gsGeigerCnt.u8GeigerMaxCOunt = ZAEHLRATEN_BEGRENZER;
#endif

#ifdef METALL_SUCHE_USED
METALLSUCH_INIT1();
METALLSUCH_INIT2();
#endif


#ifdef MAX7219_USED
MAX7219_Init();
#endif

#ifdef INT0_USED // METTALSUCH ON RED LED
// INT o used for Puls Cnt
	MCUCR |=  (1<< ISC01) | (1<< ISC00); // Rising Edge Innterrupt Sense controll
	GICR |= (1 << INT0);
#endif

#ifdef INT1_USED
// INT 1 used for Geigerzaehler
	MCUCR |=  (1<< ISC11) | (1<< ISC10); // Rising Edge Innterrupt Sense controll
	GICR |= (1 << INT1);
#endif


//gu8ProgModeFlag = AUTOMAT_RADARWACKELN_FAHREN; 
//Voreinstellung Ausgabe beimSTart
gu8TxFlag = 0; //METALL_SUCHE_TRAFFIC_ON | GEIGERZAEHLER_TRAFFIC_ON | DEBUG_TRAFFIC_ON;
gu8ProgModeFlag = 0;

gu8PWM_Left = 200;
gu8PWM_Right = 200;

gu8StateMachine = STATE_TRY_AGAIN;
//gu8StateMachine = STATE_MACH_NIX;

// ************ MAIN LOOP FOR EVER *********************
for (;;)  /* loop forever */ //Aber schnell > 100.000 mal/Sekunde
// ************ MAIN LOOP FOR EVER *********************
	{	
	sei(); // es sei
 	wdt_reset();	//WATCHDOG!
// -----------------------------------------------------
#ifdef  ODOMETRIEDATA_USED
	MyOdometrieData(gau16OdoData);
#endif

#ifdef  IR_DISTANCE_USED
	if(gu8ProgModeFlag & AUTOMAT_STATEMACHINE)
		{
		if( (gu32_Ticks % TICK_10SEKUNDEN) == 0) // ALLE 10 SEKUNDEN
			{
			gu8ProgModeFlag ^= AUTOMAT_RADARWACKELN_FAHREN; // TOGGLE BIT
			};
			
		if( gu8ProgModeFlag & AUTOMAT_RADARWACKELN_FAHREN) // Schalte hin und her..
			{
			gu8StateMachine = STATE_FAHREGERADE_MIT_IR_RADAR;
			}
		else
			{
			gu8StateMachine = STATE_SCHWENKE_DAS_IR_RADAR;
			}
		};
#endif // IR_DISTANCE_USED
// -----------------------------------------------------
// GREEN BLINK -----------------------------------------------------
	if( (gu32_Ticks - u32BlinkTick)  > gu32BlinkTime)
		{
		u32BlinkTick = gu32_Ticks;
		TOGGLE_GREEN_LED();
		};

#ifdef TICK_MSG_USED	
		//uart_puts( ultoa( gu32_Ticks, gcaStr, 10 ) );
		//uart_putc( 13 ); //CR
// *** TICKER ****** TICKER ****** TICKER ****** TICKER ****** TICKER ****** TICKER *** 		
// *** TICKER ****** TICKER ****** TICKER ****** TICKER ****** TICKER ****** TICKER *** 		
	if( (gu32_Ticks - u32Now)  >  TICK_1000MS ) //TICK_1000MS=282
		{
		u32Now = gu32_Ticks;

	
#ifdef DEBUG_TX_TRAFFIC_USED
if( gu8TxFlag & DEBUG_TRAFFIC_ON )
	{
	
	uart_puts_p(PSTR("State="));
	uart_puts( itoa( gu8StateMachine, gcaStr, 10 ) );
	uart_putc( 13 );

	// TEST REGISTER AUSGABE		
/*
	uart_puts_p(  PSTR(" DDRC=" ));
	uart_puts( itoa( DDRC,gcaStr, 10 ) );		
	uart_puts_p(  PSTR(" PORTC=" ));
	uart_puts( itoa( PORTC, gcaStr, 10 ) );		
*/
/*
	uart_puts_p(  PSTR(" MCUCR=" ));
	uart_puts( itoa( MCUCR, gcaStr, 10 ) );		

	uart_puts_p(  PSTR(" GICR=" ));
	uart_puts( itoa( GICR, gcaStr, 10 ) );		
*/
	};
#endif //DEBUG_TX_TRAFFIC_USED
		
		
#ifdef TX_TRAFFIC_USED	


#ifdef IR_DISTANCE_USED
		if(gu8TxFlag & IR_TRAFFIC_ON) //"IO"
			{	
			uart_puts_p(  PSTR("IR=" ));
			uart_puts( itoa( GetIR_Sens(), gcaStr, 10 ) );
			uart_putc( 13 );
			};
#endif
		
#ifdef  ODOMETRIEDATA_USED
		if(gu8TxFlag & ODO_TRAFFIC_ON)
			{
			uart_puts_p(  PSTR("ODO 0=" ));
			uart_puts( itoa( gau16OdoData[0], gcaStr, 10 ) );
			uart_puts_p(  PSTR(" 1=" ));
			uart_puts( itoa( gau16OdoData[1], gcaStr, 10 ) );
			
			uart_puts_p(  PSTR(" LEFTCnt=" ));
			uart_puts( ltoa( gi32ODO_Cnt_Left, gcaStr, 10 ) );

			uart_puts_p(  PSTR(" RIGHTCnt=" ));
			uart_puts( ltoa( gi32ODO_Cnt_Right, gcaStr, 10 ) );
			uart_puts_p(  PSTR(" LR=" ));
			uart_puts( itoa( gi16ODO_LR_Cnt, gcaStr, 10 ) );
			
			uart_putc( 13 );
			};
#endif	//ODOMETRIEDATA_USED	

		
#ifdef POLL_SWITCH_USED
		if(gu8TxFlag & SW_TRAFFIC_ON)
			{
			uart_puts_p(  PSTR("Switch=" ));
			uart_puts( itoa( PollSwitch(), gcaStr, 10 ) );		
			uart_puts_p(  PSTR("  ADC=" ));
			uart_puts( itoa( ADC, gcaStr, 10 ) );		
			uart_putc( 13 );
			};
#endif //POLL_SWITCH_USED
#endif //TX_TRAFFIC_USED	
		};  //  !!!!!!!!!!!!!   TickCounter 1000MS
		
		/*
		uart_puts( ltoa( gu32_Ticks, gcaStr, 10 ) );
		uart_putc( 13 );
		uart_puts( itoa( gu8ProgModeFlag, gcaStr, 10 ) );
		uart_putc( 13 );
		*/
#endif //TICK_MSG_USED		




// -----------------------------------------------------
#ifdef TX_ODO_EVENT_USED
	if( gu8TxFlag & TX_ODO_EVENT_ON )
		{
		if( gu8ODO_Status & ODOS_LEFT_EVENT )
			{
			gu8ODO_Status &= ~ODOS_LEFT_EVENT ;
			//u8Misc
			uart_puts_p(  PSTR("EVENT LEFT=" ));
			//uart_puts( itoa( gi32ODO_Cnt_Left, gcaStr, 10 ) );
			//uart_puts_p(  PSTR(" LR=" ));
			//uart_puts( itoa( gi16ODO_Cnt_LundR, gcaStr, 10 ) );
			uart_putc( 13 );
			};

		if( gu8ODO_Status & ODOS_RIGHT_EVENT )
			{
			gu8ODO_Status &= ~ODOS_RIGHT_EVENT ;
			uart_puts_p(  PSTR("EVENT RIGHT=" ));
			//uart_puts( itoa( gi32ODO_Cnt_Right, gcaStr, 10 ) );
			//uart_puts_p(  PSTR(" LR=" ));
			//uart_puts( itoa( gi16ODO_Cnt_LundR, gcaStr, 10 ) );
			uart_putc( 13 );
			};
		};
#endif	//TX_ODO_EVENT_USED		


#ifdef POLL_SWITCH_USED
	if( PollSwitch() != gu8SwitchValue )
		{
		gu8SwitchValue = PollSwitch();
		gu8ProgModeFlag |= SWITCH_EVENT_FLAG; // EVENT TASTEREREIGNIS
		// K1 = 32, K2 = 16, K3 = 8, K4 = 4, K5 = 2, K6 = 1
		if(   (gu8SwitchValue != 0)  && (gu32_Ticks < 1500U) )
			{
			gu8StateMachine = STATE_TRY_AGAIN;
			};
		switch( gu8SwitchValue )
			{
			case 1:
				{
				break;
				};			
			case 2:
				{
				break;
				};			
			case 4:
				{
				break;
				};			
			case 8:
				{
				break;
				};			
			case 16:
				{
				break;
				};			
			case 32:
				{
				break;
				};
			};//  switch

#ifdef TX_SWITCH_EVENT_USED
		if(gu8ProgModeFlag & SW_EVENT_TRAFFIC_ON)
			{
			uart_puts_p(PSTR("SW="));
			uart_puts( itoa( gu8SwitchValue, gcaStr, 10 ) );
			uart_putc( 13 );	
			};		
#endif //TX_SWITCH_EVENT_USED
		};
#endif // POLL_SWITCH_USED 

// VERY IMPORTANT
// ***************************	
	StateMachine(); // Macht alle Action
// ***************************	
// *************************
	//Toggle_Bit( 1 ); // DEBUG ***************
// *************************
	}; //main loop Ende
};
// ******************* MAIN END ********************************************
