
//Modified Christof Ermer =/CE\=   16.10.2014
/*
Fehler, , alle RAM Strings in PGM Strings gendert.
FEHLER, ADC war zu schnell %2, jetzt Prescaler %64
FEHELR ADIF falg ist ungeiegnet zum ADC coversion messug ADSC=0 

Prfe Pollswitch
Eliminiert: Sleep(x); macht nur rger, delay_us(x) ist besser
weil Counter zurckgesetzt wird, damit kein Tickcounter mehr mglich

PWM zugefgt an PD6= D11 = Linesearch Rote LED.. mu nihct ausgebaut werden

*/
/*******************************************************************************
*
* File Name:   asuro.c
* Project  :   ASURO
*
* Description: This file contains ASURO main features
*
* Ver.     Date         Author           Comments
* -------  ----------   --------------   ------------------------------
* 1.00	   14.08.2003   Jan Grewe		 build
* 2.00     14.10.2003   Jan Grewe        LEFT_VEL, RIGHT_VEL -> MotorSpeed(unsigned char left_speed, unsigned char right_speed);
*										 LeftRwd(),LeftFwd(),RightRwd(),RigthFwd() -> MotorDir(unsigned char left_dir, unsigned char right_dir);
*                                        GREEN_ON,GREEN_OFF,RED_ON,RED_OFF -> StatusLED(unsigned char color);
*                                        LED_RED_ON, LED_RED_OFF -> FrontLED(unsigned char color);
*                                        Blink(unsigned char left, unsigned char right) -> BackLED(unsigned char left, unsigned char right);
*                                        Alles in Funktionen gefasst => leichter verstndlich ?!?!
* 2.10     17.10.2003   Jan Grewe        new Timer funktion void Sleep(unsigned char time36kHz)  
*
* Copyright (c) 2003 DLR Robotics & Mechatronics
*****************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   any later version.                                                    *
***************************************************************************/

//#include "asuro.h"
#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
//Achtung alle benutzen Datentypen bentigen die Header
#include <avr\wdt.h>
//CE
#include <util\delay.h>

#include "myasuro.h"
#include "main.h" //wegen gu32_Tick =/CE\=
//#include "TxtFunc.h" 
#include "Befehle.h" // wegen UART_TXRX_Check()  =/CE\=
#include "debug.h"
//Sammle Struktur fr alle Funktionsdaten des Asuro
// GLOBALE VARIABLEN


//DIESEN WERT ANPASSEN ,das Tastenwerte kommen wie
// K1 = 32, K2 = 16, K3 = 8, K4 = 4, K5 = 2, K6 = 1

////62L, 63L, 64L oder 65
volatile unsigned char gu8Count72kHz;	//Byte Variable !!
unsigned char gu8TasterVal;// =  63;  //(Default)
//CE
#ifdef  ODOMETRIEDATA_USED
unsigned int gau16OdoData[2];	// 2*INT Array
unsigned int gau16OdoLow[2];	// 2*INT Array
unsigned int gau16OdoHigh[2];	// 2*INT Array
unsigned int gau16OdoMiddle[2];	// 2*INT Array
#endif

#ifdef 	LINEDATA_USED
unsigned int gau16LIneData[2];	// 2*INT Array
#endif

#ifdef ODOMETRIEDATA_USED
int long gi32ODO_Cnt_Left;
int long gi32ODO_Cnt_Right;
int gi16ODO_LR_Cnt;
uint8_t gu8ODO_Status;
#endif

#ifdef PWM_ON_D11_USED   //gu8PWM_D11_Val trgt die PWMZeit fr Servos
unsigned char gu8PWM_D11_Val = PWM_MITTE;  // Compare PWM
#endif


// PROGRAMM SEKTION

/* uses timer2 (36kHz for IR communication */
/* counts falling and rising edge => 36kHz*2 = 72kHz */
//SIGNAL (SIG_OUTPUT_COMPARE2)
ISR(SIG_OUTPUT_COMPARE2)
{
gu8Count72kHz++;
#ifdef PWM_ON_D11_USED   //gu8PWM_D11_Val trgt die PWMZeit fr Servos
if( (! gu8Count72kHz) && !( gu32_Ticks % 5) ) //281/5 so wird ~55HZ PWM draus.
	{
	SERVO_D11_HIGH();  	//MAKRO PWM PIN +5V      
	};

//Erweiterung  =/CE\=
if( gu8Count72kHz == gu8PWM_D11_Val)
	{
	SERVO_D11_LOW();  	//MAKRO PWM PIN +5V      
	};
#endif
// GEFAHR //gu8Count72kHz = 0; fhrt zu berlaufverhinderung = STop  des 2. Tickzhlers
//Erweiterung  =/CE\=
if(!gu8Count72kHz) //! bedeutet: wenn 0 dann  = 
//~282  // Zhlt ~8MHz / 111 = 72000/256=281.5315315 	
	{
	gu32_Ticks++;
	UART_TXRX_Check();  // langsamer aber oft sehen ob was kommt an UART = Serielle Schnittstelle.
	};
};



/* Init function Processor will be initalized to work correctly */
void Init (void)
{	
//falsch stellen
#ifdef  ODOMETRIEDATA_USED
gau16OdoLow[0]=65535;	// 2*INT Array
gau16OdoLow[1]=65535;	// 2*INT Array
gau16OdoHigh[0]=0;	// 2*INT Array
gau16OdoHigh[1]=0;	// 2*INT Array
#endif

gu8TasterVal = MY_SWITCH_VALUE; //  MY_SWITCH_VALUE 63  //(Default)

//-------- seriell interface programmed in boot routine and already running -------
//  prepare 36kHz for IR - Communication
TCCR2 = (1 << WGM21) | (1 << COM20) | (1 << CS20);
//OCR2  = 0x6E; // 36kHz @8MHz
// =/CE\=
OCR2  = 0x6F; // =111 = (CE) genauer !! 111.1111
TIMSK |= (1 << OCIE2); // 36kHz counter for sleep
/*	=/CE\=
// prepare RS232 
UCSRA = 0x00;
UCSRB = 0x00;	
UCSRC = 0x86; // No Parity | 1 Stop Bit | 8 Data Bit
UBRRL = 0xCF; // 2400bps @ 8.00MHz
*/	
// I/O Ports
#ifdef GREENLED_USED_ONLY
DDRB = IRTX | LEFT_DIR | PWM | GREEN_LED; 
#else
DDRB = IRTX | LEFT_DIR | PWM; 
#endif

#ifdef REDLED_USED_ONLY
DDRD = RIGHT_DIR | FRONT_LED | ODOMETRIE_LED | RED_LED;
#else
DDRD = RIGHT_DIR | FRONT_LED | ODOMETRIE_LED;
#endif
//CE
SERVO_DIRREG |= SERVO_D11_PIN;

// for PWM (8-Bit PWM) on OC1A & OC1B
TCCR1A = (1 << WGM10) | (1 << COM1A1) | (1 << COM1B1);
// tmr1 running on MCU clock/8 
TCCR1B = (1 << CS11);

// A/D Conversion
ADCSRA = (1 << ADIF) | (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1);   //ADC EIN UND PreScaler /64

ODOMETRIE_LED_OFF();

#ifdef FRONTLED_USED //in myasuh.h
FrontLED(OFF);
#endif

#ifdef BACKLED_USED //in myasuh.h
//BackLED(ON,ON);
BackLED(OFF,OFF)
#endif

#ifdef GREENLED_USED_ONLY //in myasuh.h  ON!!!
StatusLED(GREEN);  // Init done
#endif

MotorDir(FWD,FWD);
MotorSpeed(0,0);
sei();
};

/* Set motor speed */
//inline void MotorSpeed(unsigned char left_speed, unsigned char right_speed)
void MotorSpeed(unsigned char left_speed, unsigned char right_speed)
{
	OCR1A = left_speed;
	OCR1B = right_speed;
};

/* Set motor direction */
//inline void MotorDir(unsigned char left_dir, unsigned char right_dir)
void MotorDir(unsigned char left_dir, unsigned char right_dir)
{
PORTD = (PORTD &~ ((1 << PD4) | (1 << PD5))) | left_dir;
PORTB = (PORTB &~ ((1 << PB4) | (1 << PB5))) | right_dir;

if( left_dir == FWD )
	{
	gu8ODO_Status &= ~ODOS_LEFT_DIR;
	};
if( left_dir == RWD )
	{
	gu8ODO_Status |= ODOS_LEFT_DIR;
	};

if( right_dir == FWD )
	{
	gu8ODO_Status &= ~ODOS_RIGHT_DIR;
	};
if( right_dir == RWD )
	{
	gu8ODO_Status |= ODOS_RIGHT_DIR;
	};
};


/* Status LED (OFF,GREEN,YELLOW,RED)*/
/* example code set StatusLED GREEN */
/* StatusLED(GREEN); */
//inline void StatusLED(unsigned char color)
void StatusLED(unsigned char color)
{
#ifdef STATUSLED_USED
	if (color == OFF)    {GREEN_LED_OFF(); RED_LED_OFF();}
	if (color == GREEN)  {GREEN_LED_ON(); RED_LED_OFF();} 
	if (color == YELLOW) {GREEN_LED_ON(); RED_LED_ON();}
	if (color == RED)    {GREEN_LED_OFF(); RED_LED_ON();}
#endif

// ENTWEDER ODER 
#ifdef REDLED_USED
	if (color == RED)    {RED_LED_ON();}
	if (color == OFF)    {RED_LED_OFF();}
#endif
#ifdef GREENLED_USED_ONLY
	if (color == GREEN)  {GREEN_LED_ON(); } 
	if (color == OFF)    {GREEN_LED_OFF();}
#endif
};



#ifdef FRONTLED_USED
/* Front LED */
/* example code FrontLED ON */
/* FrontLED(ON); */
//inline void FrontLED(unsigned char status)
void FrontLED(unsigned char status)
{
	PORTD = (PORTD &~(1 << PD6)) | (status << PD6); // Erst lschen , dan setzen oder nicht
};

#endif

#ifdef BACKLED_USED
/* function for Break LEDs */
/* example code right LED On left LED Off */
/* BackLED(OFF,ON); */
void BackLED(unsigned char left, unsigned char right)
{
	if (left || right) {
		PORTD &= ~(1 << PD7); // Wheel LED OFF
		DDRC |= (1 << PC0) | (1 << PC1); // Output => no odometrie
		PORTC &= ~((1 << PC0) | (1 << PC1));
//		PORTC |= (1 << PC0) | (1 << PC1);
	}
//	if (!left) PORTC &= ~(1 << PC1);
//	if (!right) PORTC &= ~(1 << PC0);
	if (left) PORTC |= (1 << PC1);
	if (right) PORTC |= (1 << PC0);
};
#endif

#ifdef LINEDATA_USED
/* function to read out line follow phototransistors (left,rigth) */
void LineData(unsigned int *data)
{ // 2 Messungen 
	ADCSRA = (1 << ADIF) | (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1);	//enable+INT clear+%64 Prescaler
	ADMUX = (1 << REFS0) | IR_LEFT;	// AVCC reference with external capacitor
	_delay_us(140);  // REF muss stabil sein
	ADCSRA |= (1 << ADIF) | (1 << ADSC);			// Start conversion
//ORG while (!(ADCSRA & (1 << ADIF)));	// wait for conversion complete
	while( ADCSRA & (1<< ADSC) ){wdt_reset();};	//wait until _BV(ADSC)=0 =converstion completed
	ADCSRA |= (1 << ADIF);			// clear ADCIF
	//data[0] = ADCL + (ADCH << 8);
	data[0]=ADC;

	ADMUX = (1 << REFS0) | IR_RIGHT;	// AVCC reference with external capacitor
	_delay_us(140);  // REF muss stabil sein
	ADCSRA |= (1 << ADIF) | (1 << ADSC);			// Start conversion
//ORG while (!(ADCSRA & (1 << ADIF)));	// wait for conversion complete
	while( ADCSRA & (1<< ADSC) ){wdt_reset();};	//wait until _BV(ADSC)=0 =converstion completed
	ADCSRA |= (1 << ADIF);			// clear ADCIF
	//data[1] = ADCL + (ADCH << 8);
	data[1]=ADC;
};
#endif

#ifdef ODOMETRIEDATA_USED_ORG_USED
/* function to read out odometrie phototransistors (left,rigth) */
void OdometrieData(unsigned int *data)

{
	DDRC &= ~((1 << PC0) | (1 << PC1)); // Input => no break LED	ODOMETRIE_LED_ON();
	PORTC &= ~((1 << PC0) | (1 << PC1)); // PULL OFF !!
	ADCSRA = (1 << ADIF) | (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1);	//enable+INT clear+%64 Prescaler
	ADMUX = (1 << REFS0) | WHEEL_LEFT; // AVCC reference with external capacitor
	_delay_us(150);  // REF muss stabil sein
//ORG 	ADCSRA |= (1 << ADSC);			// Start conversion
//ORG WRONG while (!(ADCSRA & (1 << ADIF)));	// wait for conversion complete
//CE
	ADCSRA |= (1 << ADIF) |  (1<< ADSC);	//Start conversion
	while( ADCSRA & (1<< ADSC) ){wdt_reset();};	//wait until _BV(ADSC)=0 =converstion completed
//ORG ADCSRA |= (1 << ADIF);			// clear ADCIF
//	data[0] = ADCL + (ADCH << 8);
	data[0] = ADC;
	
	ADCSRA = (1 << ADIF) | (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1);	//enable+INT clear+%64 Prescaler
	ADMUX = (1 << REFS0) | WHEEL_RIGHT; // AVCC reference with external capacitor
	_delay_us(150);  // REF muss stabil sein
//ORG 	ADCSRA |= (1 << ADSC);			// Start conversion
	ADCSRA |= (1 << ADIF) |  (1<< ADSC);	//Start conversion
//ORG WRONG while (!(ADCSRA & (1 << ADIF)));	// wait for conversion complete
	while( ADCSRA & (1<< ADSC) ){wdt_reset();};	//wait until _BV(ADSC)=0 =converstion completed
//ORG ADCSRA |= (1 << ADIF);			// clear ADCIF
//	data[1] = ADCL + (ADCH << 8);
	data[1] = ADC;
};
#endif

#ifdef  ODOMETRIEDATA_USED
/* function to read out odometrie phototransistors (left,rigth) */
void MyOdometrieData(unsigned int *data)
{
	DDRC &= ~((1 << PC0) | (1 << PC1)); // Input => no break LED
	//CE es kann backlight ON = PULL ON sein..
	PORTC &= ~((1 << PC0) | (1 << PC1)); // PULL OFF !!
	
	ODOMETRIE_LED_ON();
/*	
	ADCSRA = (1 << ADIF) | (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1);	//enable+INT clear+%64 Prescaler
	ADMUX = (1 << REFS0) | WHEEL_LEFT; // AVCC reference with external capacitor
	_delay_us(150);  // REF muss stabil sein
//ORG 	ADCSRA |= (1 << ADSC);			// Start conversion
//ORG WRONG while (!(ADCSRA & (1 << ADIF)));	// wait for conversion complete
//CE
	ADCSRA |= (1 << ADIF) |  (1<< ADSC);	//Start conversion
	while( ADCSRA & (1<< ADSC) ){wdt_reset();};	//wait until _BV(ADSC)=0 =converstion completed
//ORG ADCSRA |= (1 << ADIF);			// clear ADCIF
//	data[0] = ADCL + (ADCH << 8);
*/
	data[0] = ADC_AT8_10Bit(ADC_5V_AN_C | WHEEL_LEFT);
	
	if (data[0] < gau16OdoLow[0])
		{
		gau16OdoLow[0]=data[0];
		};
	if (data[0] > gau16OdoHigh[0])
		{
		gau16OdoHigh[0]=data[0];
		};
	gau16OdoMiddle[0] = ((gau16OdoHigh[0] - gau16OdoLow[0]) / 2) + gau16OdoLow[0];
	
	
/*	
	ADCSRA = (1 << ADIF) | (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1);	//enable+INT clear+%64 Prescaler
	ADMUX = (1 << REFS0) | WHEEL_RIGHT; // AVCC reference with external capacitor
	_delay_us(150);  // REF muss stabil sein
//ORG 	ADCSRA |= (1 << ADSC);			// Start conversion
	ADCSRA |= (1 << ADIF) |  (1<< ADSC);	//Start conversion
//ORG WRONG while (!(ADCSRA & (1 << ADIF)));	// wait for conversion complete
	while( ADCSRA & (1<< ADSC) ){wdt_reset();};	//wait until _BV(ADSC)=0 =converstion completed
//ORG ADCSRA |= (1 << ADIF);			// clear ADCIF
//	data[1] = ADCL + (ADCH << 8);
*/
	data[1] = ADC_AT8_10Bit(ADC_5V_AN_C | WHEEL_RIGHT);
	if (data[1] < gau16OdoLow[1])
		{
		gau16OdoLow[1]=data[1];
		};
	if (data[1] > gau16OdoHigh[1])
		{
		gau16OdoHigh[1]=data[1];
		};
	gau16OdoMiddle[1] = ((gau16OdoHigh[1] - gau16OdoLow[1]) / 2) + gau16OdoLow[1];		

// TO DO 29.9..

	// MITTE IST NOCH NIHCT AUSGEWERTET...!!!!
	//extern uint8_t Abweichung(int16_t i16Val1,int16_t i16Val2, uint8_t i16Difference); // true /False
	
	
	//3 VARIABLEN DIE ODO ZHLEN EINE +/-
	/*
	int gi16ODO_LR_Cnt;
int gi32ODO_Cnt_Left;
int gi32ODO_Cnt_Right;
	*/
//LOW --> HIGH 
if( Abweichung( data[0], gau16OdoMiddle[0], ODO_HYSTERESE) ) // DIFF OK
	{
	if( (data[0] > gau16OdoMiddle[0]) &&  // richtung HIGH
		!(gu8ODO_Status & ODOS_LEFT_LOWHIGH) // WENN vorher 0
	)
		{
		gu8ODO_Status |= ODOS_LEFT_LOWHIGH | ODOS_LEFT_EVENT ;
		//gu8ODO_Status ^= BACKLED_LEFT;
		//BackLED( (gu8ODO_Status & BACKLED_LEFT), (gu8ODO_Status & BACKLED_RIGHT) );
		if(gu8ODO_Status & ODOS_LEFT_DIR) //Rckwertoof
		
			{
			gi32ODO_Cnt_Left--;
			}
		else
			{
			gi32ODO_Cnt_Left++;
			};	
		gi16ODO_LR_Cnt = gi32ODO_Cnt_Left - gi32ODO_Cnt_Right;	
		};

// HIGH --> LOW
	if( (data[0] < gau16OdoMiddle[0]) && // richtung LOW
		(gu8ODO_Status & ODOS_LEFT_LOWHIGH)	// war vorher  1
	)
		{
		gu8ODO_Status &= ~ODOS_LEFT_LOWHIGH;
		
		//gu8ODO_Status ^= BACKLED_LEFT;
		//BackLED( (gu8ODO_Status & BACKLED_LEFT), (gu8ODO_Status & BACKLED_RIGHT) );

		gu8ODO_Status |= ODOS_LEFT_EVENT;
		if(gu8ODO_Status & ODOS_LEFT_DIR)
			{
			gi32ODO_Cnt_Left--;
			}
		else
			{
			gi32ODO_Cnt_Left++;
			};
		gi16ODO_LR_Cnt = gi32ODO_Cnt_Left - gi32ODO_Cnt_Right;
		};
	};

//RIGHT alles nochmals 
if( Abweichung( data[1], gau16OdoMiddle[1], ODO_HYSTERESE) )
	{
	if( (data[1] > gau16OdoMiddle[1]) &&
		!(gu8ODO_Status & ODOS_RIGHT_LOWHIGH) // noch low
	)
		{
		gu8ODO_Status |= ODOS_RIGHT_LOWHIGH | ODOS_RIGHT_EVENT;
		//gu8ODO_Status ^= BACKLED_RIGHT;
		//BackLED( (gu8ODO_Status & BACKLED_LEFT), (gu8ODO_Status & BACKLED_RIGHT) );
		if(gu8ODO_Status & ODOS_RIGHT_DIR)
			{
			gi32ODO_Cnt_Right--;
			}
		else
			{
			gi32ODO_Cnt_Right++;
			};
		gi16ODO_LR_Cnt = gi32ODO_Cnt_Left - gi32ODO_Cnt_Right;
		};

	if( (data[1] < gau16OdoMiddle[1]) &&
		(gu8ODO_Status & ODOS_RIGHT_LOWHIGH)
	)
		{
		gu8ODO_Status &= ~ODOS_RIGHT_LOWHIGH ;
		gu8ODO_Status |= ODOS_RIGHT_EVENT;
		//gu8ODO_Status ^= BACKLED_RIGHT;
		//BackLED( (gu8ODO_Status & BACKLED_LEFT), (gu8ODO_Status & BACKLED_RIGHT) );
		if(gu8ODO_Status & ODOS_RIGHT_DIR)
			{
			gi32ODO_Cnt_Right--;
			}
		else
			{
			gi32ODO_Cnt_Right++;
			};
		gi16ODO_LR_Cnt = gi32ODO_Cnt_Left - gi32ODO_Cnt_Right;
		};
	};
};//MyOdometrieData
#endif


#ifdef ORGINAL_ASURO_FNCTION_ENABLED	
/* function for serial communication */
/*
void SerWrite(unsigned char *data,unsigned char length)
{
	unsigned char i = 0;
	UCSRB = 0x08; // enable transmitter
	while (length > 0) {
		if (UCSRA & 0x20) { // wait for empty transmit buffer
			UDR = data[i++];
			length --;
		}
	}
	while (!(UCSRA & 0x40)); 
	for (i = 0; i < 0xFE; i++)
		for(length = 0; length < 0xFE; length++); 
};

void SerRead(unsigned char *data, unsigned char length,unsigned int timeout)
{
	unsigned char i = 0;
	unsigned int  time = 0;
	UCSRB = 0x10; // enable receiver
	// non blocking
	if (timeout != 0) {
		while (i < length && time++ < timeout) {
			if (UCSRA & 0x80) {
				data[i++] = UDR;
				time = 0;
			}
		}
		if (time > timeout) data[0] = 'T';
	}
	// blocking
	else {
		while (i < length) {
			if (UCSRA & 0x80) 
				data[i++] = UDR;
		}
	}	
};
*/
#endif

//  SIEHE http://www.asurowiki.de/pmwiki/pmwiki.php/Main/Tasten
//DIESEN WERT ANPASSEN ,das Tastenwerte kommen wie
// K1 = 32, K2 = 16, K3 = 8, K4 = 4, K5 = 2, K6 = 1
//#define MY_SWITCH_VALUE 63L
////62L, 63L, 64L oder 65
/* function to read out switches */
#ifdef POLL_SWITCH_USED
unsigned char PollSwitch(void)
// gu8TasterVal = 63 einegfhrt um Abweichung kompensieren zu knnen
{
	DDRD |= SWITCHES;	//(1 << PD3)			// Switches as Output
#ifndef GEIGERZAEHLER_USED  // AB JETZ MUSS DER 1K dauerhaft auf V+ liegen, nicht maher an INT1
	SWITCH_ON();		//(PORTD |= (1 << PD3)	// Output HIGH for measurement
#endif
/*
	ADCSRA = (1 << ADIF) | (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1);	//enable+INT clear+%64 Prescaler
	ADMUX = (1 << REFS0) | (1 << MUX2); // SWITCH;	//ADC4 = (1 << MUX2)  AVCC 5V reference with external capacitor
//ORG Sleep(10); !! // Setzt u8Count72kHz auf 0
	_delay_us(100);  //  // 1.4*10^-4  1/72000 * 10
	
//CE
	//org while (!(ADCSRA & (1 << ADIF))){};// clear ADCIF};// wait for conversion complete
 	ADCSRA |= (1 << ADSC) ;			// Start conversion
	while( ADCSRA & (1<< ADSC) ){wdt_reset();};	//wait until _BV(ADSC)=0 =converstion completed
	//	ADCSRA |= (1 << ADIF); //frher da
	//u16i = ADCL + (ADCH << 8);  //CE veraltet	
*/
//#define MUX2	2    --> 100 ADC4
	ADC_AT8_10Bit( ADC_5V_AN_C | (1 << MUX2) );
//CE habs raus !!
#ifndef GEIGERZAEHLER_USED
	SWITCH_OFF();	//WARUM eigentlich aus ??
#endif
//ORGINAL 	return  ((unsigned char) ((( 1024.0/(float)ADC - 1.0)) * 63.0 + 0.5));
// alles *1000
// return ( ((10240000L / (long)(uiADC+1) - 10000L) * MY_SWITCH_VALUE + 5000L) / 10000);
	return  (unsigned char)(((10240000L / (long)(ADC + 1) - 10000L) * ((long)gu8TasterVal) + 5000L) / 10000);
	//return  ADC;  
};
#endif //POLL_SWITCH_USED

#ifdef ADC_USED_ENABLED
/*
REFERENCE Anstiegszeit 2.56-..5 = 50uS an 100nF
REFERENCE Abfallzeit = 7,5mS mit 100nF
*/
// ****************************************************
uint16_t ADC_AT8_10Bit(uint8_t u8Chan) // 0..7
// ****************************************************
{//NOW.. mit dem Chanel wird REFEREnCE Mit auf-Odiert..
// No ISR(SIG_ADC)
//DIESE DEFINES MIT OR_EN
#define ADC_BANDGAP_VOLTAGE	2.56  // zur verrechnung
#define ADC_EXTERN_5V	0x00
#define ADC_5V_AN_C		0x40 //(1<< REFS0)
#define ADC_INTERN_BANDGAP_2_56V	0xC0 //((1<< REFS1) | (1<< REFS0))	
//uint8_t u8Cnt=0;
DDRC &= ~_BV(u8Chan);  //Bit loeshcne von port A,Chanel Bit Input  
PORTC &= ~_BV(u8Chan); //Wegen Pullup abschalten

// %128 //ADCSRA = (1<< ADEN) | (1<< ADIE) | (1<< ADPS2) | (1<< ADPS1) | (1<< ADPS0);   //ADC INT EIN UND PreScaler /128
ADCSRA = (1 << ADIF) | (1<< ADEN) | (1<< ADPS2) | (1<< ADPS1);   //ADC EIN UND PreScaler /64

/*//OLD STILE  DONT USE
#ifdef ADC_EXTERN_5V_USED_ENABLED
ADMUX =  u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
#ifdef ADC_5V_AN_C_USED_ENABLED
ADMUX =  (1<< REFS0) | u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
#ifdef ADC_INTERN_BANDGAP_USED_ENABLED
ADMUX = (1<< REFS1) | (1<< REFS0) | u8Chan;	// ADMUX_REFS0 Select pin ADCx using MUX  
#endif
*/
//NEW STILE, append define like  "| ADC_5V_AN_C"

ADMUX = u8Chan; //Hier unbedingt die REFERENCE DEFINES mit | OR-en
_delay_us(100); // 1.4*10^-4
ADCSRA |= (1 << ADIF) |  (1<< ADSC);	//ADCSRA |= _BV(ADSC);	//Start conversion
while( ADCSRA & (1<< ADSC) )	//wait until _BV(ADSC)=0 =conversion completed
	{
	wdt_reset();
	};	
ADCSRA |= (1 << ADIF);	// clear ADCIF	
return ADC;	//ADCW; //get converted value
};
#endif


// MEINE SLEEP VERSION
// *******************************
void SleepMS(uint32_t u32MSeconds)
// *******************************
{
uint16_t u16NN=0;
while( u16NN < u32MSeconds)
	{ _delay_ms(1); wdt_reset();u16NN++;};	//WATCHDOG!	
};

/*
// for working with Interrup
void StartSwitch(void)
{
	SWITCH_OFF();
	DDRD &= ~SWITCHES;					// Switches as Input => ext. Int 1
	MCUCR &= ~((1 << ISC11) | (1 << ISC10));// Low level generates interrupt
	GICR |= (1 << INT1);					// Enable external Interrupt 1 
};

void StopSwitch(void)
{
	GICR &= ~(1 << INT1);
};
*/
// /CE\ Sehr kurz   
/// uses 72kHz timer => Sleep(x) = x/72kHz [sec]
// GEFAHR //gu8Count72kHz = 0; fhrt zu berlaufverhinderung = STop  des 2. Tickzhlers
/*
void Sleep(unsigned char time72kHz)
{
	uint8_t u8Merk = gu8Count72kHz;
	//gu8Count72kHz = 0; // NICHT 0 stellen.. !
//	while ( (gu8Count72kHz  < time72kHz);
	while( (gu8Count72kHz - u8Merk) < time72kHz){};
};
*/