
#ifndef STATEMACHINE_HEADER
	#define STATEMACHINE_HEADER
	

#define VOMSTART_TIMEOUT 8460U // 30Sekunden
#define DEMO_MOVE_IR_RADAR  // in statmach.c
#define IR_ZUNAHE		220
#define IR_SEARCH_DELAY 50

#define ZUNAHE_FAHRZEIT_MS	50
#define IRSUCH_RUECK_FAHRZEIT_MS	25

//???
#define SF_NIX_GEFUNDEN 0x01
#define IRGENDWO_ANGERUMPELT 0x02
#define MOTOR_ACTIVE  0x04
/* #define ??SF_NIX_GEFUND??   0x02
0x01
0x02
0x04
0x08
0x10
0x20
0x40
0x80
//gu8StateFlag

jetzt kann ich fragen 
if( gu8StateFlag & SF_NIX_GEFUNDEN ) 
	{
	}
	SEZTZEN --> gu8StateFlag |= SF_NIX_GEFUNDEN
 --> gu8StateFlag |= SF_NIX_GEFUNDEN
*/
	
//STATE MACHINE  
//(Fortlaufende Nummern von 0..255, frei erfindbar..  )
#define STATE_MACH_NIX			0
#define STATE_DONE_AUTOSTART  	2
#define STATE_IR_AUTOSTOP		5
#define STATE_TRY_AGAIN			20
#define STATE_GUCKE_GERADE 		25
#define STATE_IR_SEARCH_START	30
#define STATE_IR_SEARCH_ACTIVE	33
#define STATE_OBJEKT_ZUNAHE		45
#define STATE_FREIERPLATZ_GEFUNDEN 	50
#define STATE_SACKGASSE_STECKEFEST	55
#define STATE_FREE				60
#define STATE_STOP				61
#define STATE_FAHRE_VORWAERTS	62
#define STATE_FAHRE_RUECKWAERTS	63
#define STATE_DREHE_RECHTS		64
#define STATE_DREHE_LINKS		65
#define STATE_SCHWENKE_DAS_IR_RADAR	222
#define STATE_FAHREGERADE_MIT_IR_RADAR 233
//gu8StateMachine
	
extern void Drehe( uint8_t u8Dir, uint16_t u16Weite );

extern void StateMachine(void);
extern uint8_t gu8StateMachine;  //CASES
extern unsigned int gu16StateFlags;		//Flags
extern uint8_t gu8PWM_Left;
extern uint8_t gu8PWM_Right;

extern volatile uint16_t gu16IR_Sensibility;

//ZUSTANDSSPEICHER FR WAS AUCH IMMER
// FLAGS IMMER mit einzelnen BITS kenzeichnen ->> 
//0x0001  fr 16 Bit oder Byte:  0x01, 0x02,0x04,0x08,0x10,0x20,0x40,0x80 usw
#define STATE_BLINK_GREEN	0x0001
#define STATE_BLINK_RED		0x0002
//uint16_t gu16StateFlags;

#endif //STATEMACHINE_HEADER



