
#include <stdlib.h>
#include <math.h>
#include <stdarg.h>
#include <string.h>

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\pgmspace.h> //<--#include <progmem.h>

#include <util\delay.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
//#include <avr\eeprom.h>	
//#include <avr\twi.h>
//#include <avr\signal.h> //#include <signal.h>
#include "74595.h"



//GLOBAL
uint8_t gu8aTTL74595[ NUMBER_OF_74595 ];//Gobales Array mit Bytezahl der benutzen Shiftregister
//GLOBAL


// *******************************************************************
void Write_OUT74HC595( uint8_t * pca74HC595 )  // mit pointer auf array
// *******************************************************************
{
uint8_t u8NN;
uint8_t u8AA; // 74595 Cnt
 
TTL74595_SCK_LOW();
TTL74595_SCL_LOW(); //Diese Leitung Knnte auch immer High sein.
_delay_us(1);
TTL74595_SCL_HIGH(); // clear only SAhiftregister
_delay_us(1);
u8AA = NUMBER_OF_74595 -1;
do
	{
	u8NN = 7;
	do
		{  // Clock out bits from the eo array
		 if( pca74HC595[u8AA] & (1UL << u8NN) ) 	// Ist es undiert eine EINS ?
			{	 
			TTL74595_SERDATA_HIGH();     
			}		 
		 else
			{	
			TTL74595_SERDATA_LOW();	
			};	 
		_delay_us(1);
		TTL74595_SCK_HIGH();	//Shift clock
		_delay_us(1);
		TTL74595_SCK_LOW();
	  }while( u8NN-- );
	}while(u8AA--);  //NUMBER_OF_74595
TTL74595_RCK_HIGH(); // Latch Data to Output
_delay_us(1);
TTL74595_RCK_LOW();
};
