

#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER
//#define USE_ERROR_FLAG
//#define USE_TOGGLE_FLAG
#define TIMER2_USED		//TickCounter  MUSS SEIN !!!

//#define ADC_USED_ENABLED
#define TEXT_SERVICE_USE_ENABLED
#define UART_USE_ENABLED
#define UART_ERRORMSG

#define COMAMNDSIZEMAX	64 //16 Commands

typedef struct
	{
	char caCmd[COMAMNDSIZEMAX +1];
	float fCmdVal_1;
	float fCmdVal_2;
	float fCmdVal_3;
	float fCmdVal_4;
	//char * pMsg; // Evtl dritter Paramter, fr Texte, LCD etc.
//uint8_t ucCmdID;
	}COMMAND_TYPE;


#define RX_STRMAX 128
#define STRMAX 128
#define NUMMAX 64
#define FLOAT_PRAEDIGITS_MAX	6 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define FLOAT_DIGITS_MAX		3 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);

#define DELIMITER		','
#define DELIMITERSTR	","

#define LOW_NIPPEL_MSC	0x0F
#define HIGH_NIPPEL_MSC	0xF0

//TTT
// Hardwareassignment
//#define           11059200L Hz   
// -F_CPU  in makefile !!!
#define UART_BAUD_RATE	9600	/* 9600 baud */

#define DISABLE_ALL_PULLUP_MAC	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL_MAC	(SFIOR &= ~(_BV(PUD)));

//DELAY
#define TICK_SEKUNDE 122 	//#define TCCR2_CLK_256
#define TICK_500MS	61
//NUR UNGEFHR
#define TIMEOUT_1_5MS 	1 
#define TIMEOUT_2_9MS 	2
#define TIMEOUT_4_4MS 	3
#define TIMEOUT_10_3MS 	7
#define TIMEOUT_100_7MS	68
#define TIMEOUT_500_7MS	338
#define TIMEOUT_1S 		675		//!!  uint16_t
#define TIMEOUT_5S 		3375	//!!  uint16_t

//REGISTER
#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_STOP	0x00	
#define TCCR0_CLK_0		0x01	
#define TCCR0_CLK_8		0x02	
#define TCCR0_CLK_64		0x03	
#define TCCR0_CLK_256	0x04	
#define TCCR0_CLK_1024	0x05	
#define TCCR0_EXT_CLK_FALL_T0	0x06	
#define TCCR0_EXT_CLK_RISE_T0	0x07	

#define TCCR2_WGM_NORMAL		0x00
#define TCCR2_CTC_MODE			0x08
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_CLK_STOP			0x00
#define TCCR2_FASTPWM			0x48
#define TCCR2_CS_BIST			0x0x
#define TCCR2_CLK_1024	0x07	
#define TCCR2_CLK_256	0x06	
#define TCCR2_CLK_128	0x05
#define TCCR2_CLK_64		0x04
#define TCCR2_CLK_32		0x03
#define TCCR2_CLK_8		0x02
#define TCCR2_CLK_0		0x01	
#define TCCR2_CLK_STOP	0x00	

#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CTC_MODE				0x08
#define TCCR1B_CLOCKSEL_CPU_1		0x01
#define TCCR1B_CLOCKSEL_CPU_8		0x02
#define TCCR1B_CLOCKSEL_CPU_64	0x03
#define TCCR1B_CLOCKSEL_CPU_256	0x04
#define TCCR1B_CLOCKSEL_CPU_1024	0x05

///TIMER
#define TIMSK_TOIE0_FLAG	0x01
#define TIMSK_OCIE0_FLAG	0x02
#define TIMSK_TOIE1_FLAG	0x04
#define TIMSK_OCIE1B_FLAG	0x08
#define TIMSK_OCIE1A_FLAG	0x10
#define TIMSK_TICIE1_FLAG	0x20
#define TIMSK_TOIE2_FLAG	0x40
#define TIMSK_OCIE2_FLAG	0x80

#define TIMSK_T0_CLR_ALL_MASK 0b11111100
#define TIMSK_T1_CLR_ALL_MASK 0b11000011
#define TIMSK_T2_CLR_ALL_MASK 0b00111111

//INTERUPT CTRL REG //NICHT mit MCUCSR verwechseln !
#define MCUCR_LOWLEVEL_INT0		0x00	
#define MCUCR_ANYCHANGE_INT0	0x01 //=_BV(ISC01) 	
#define MCUCR_FALLING_EDGE_INT0	0x02	
#define MCUCR_RISING_EDGE_INT0	0x03

#define MCUCR_LOWLEVEL_INT1		0x00	
#define MCUCR_ANYCHANGE_INT1	0x04 //=_BV(ISC10) 	
#define MCUCR_FALLING_EDGE_INT1	0x08	
#define MCUCR_RISING_EDGE_INT1	0x0C

#define GATE_ANYCHANGE_INT1_MODE_MAC	(MCUCR |= MCUCR_ANYCHANGE_INT1)


//Global Interrrupt CTRL REG
#define GICR_INT0_ON_MAC()		(GICR |= _BV(INT0)) //_BV(INT0)
#define GICR_INT0_OFF_MAC()		(GICR &= ~(_BV(INT0)))
#define GICR_INT1_ON_MAC()		(GICR |= _BV(INT1))
#define GICR_INT1_OFF_MAC()		(GICR &= ~(_BV(INT1)))
#define GICR_INT_01_OFF_MAC()	(GICR &= 0x3F)  //SIEHE DATENBLATT


#define RCO_B_INT_ON_MAC	GICR_INT0_ON_MAC 
#define RCO_B_INT_OFF_MAC	GICR_INT0_OFF_MAC
#define GATE_INT1_ON_MAC	GICR_INT1_ON_MAC
#define GATE_INT1_OFF_MAC	GICR_INT1_OFF_MAC


#define OVERFLOW_CNT_ON_INT0_MAC	RCO_B_INT_ON_MAC
#define OVERFLOW_CNT_OFF_INT0_MAC	RCO_B_INT_OFF_MAC

#define GATE_ALL_EVENT_ON_INT1_MAC	GATE_INT1_ON_MAC
#define GATE_ALL_EVENT_OFF_INT1_MAC	GATE_INT1_OFF_MAC

//GIFR  I_FLAG
#define GIFR_INTF0_SET_MAC	(GIFR |= _BV(INTF0)) //_BV(INT0)
#define GIFR_INTF0_CLR_MAC	(GIFR &= ~(_BV(INTF0)))
#define GIFR_INTF1_CLR_MAC	(GIFR |= _BV(INTF1))
#define GIFR_INTF1_SET_MAC	(GIFR &= ~(_BV(INTF1)))
#define GIFR_INTF_0u1_CLR_MAC	(GIFR &= 0x3F) //Siehe Datenblatt = letzten beiden Bits



//PORTB 
#define MOSI_I         3//BIT3
#define MISO_0         4//BIT4
#define SCK_I          5//BIT5




//EEPROM
#define EEPROM_SECTION  __attribute__ ((section (".eeprom")))
#define IEEPROM_SIZE	512	//Interne EEPROM
#define EE_DUMMYLOAD 0x5AA5 //unwahrsch. wert 0101 1010 1010 0101
//If using 8 block by 512 max = 64 Byte/block
//#define IEEPROM_SECTIONSIZE	64   //by 8 Section




//INTERRUPT
#define INTx_INPORT	PIND
//#define INT1_MASK	0x08  //PD3
//#define INT0_MASK	0x04  //PD2
#define INT0_PIN_NR	PD2
#define INT1_PIN_NR	PD3


//PORTB
#define TWI_DIRREG		DDRC
#define TWI_OUT_PORT	PORTC
#define TWI_IN_PORT		PINC
#define TWI_SDA			PC4		//PC4	OUT
#define TWI_SCL			PC5		//PC5	IN

//========================================================================

//TIMERS
//TIMER2  = is 61 miliseconds Timer ~approx.
// 16MhZ / 1024 / 256  = 61,03515625 Hz
// T= 1/f = 0.016384 ms / Interrupt
#define TIMER2_INT_FREQUENCY	61.03515625
#define TIMER2_INTPERIODE		0.016384 //1/TIMER2_INT_FREQUENCY BY EVERY OVERFLOW = 1 Second!
#define ONE_SECOND_TICKS		61	//1/ TIMER2_INTPERIODE
#define LONG_10DELAY_TICKS		610	//1/ TIMER2_INTPERIODE
//#define SM_AFTERSTOPDELAY_TICKS	2	//~16ms 1=TIMER2_INTPERIODE,

#define WDTO_2S   7 //WatchDog

#define ASC_CR	13

//COMMAND
#define DELIMITER		','
#define DELIMITERSTR	","


//ADC //AT8
#define ADMUX_MUX0		0x01
#define ADMUX_MUX1		0x02
#define ADMUX_MUX2		0x04
#define ADMUX_MUX3		0x08
#define ADMUX_MUX_1_23V	0xE0
#define ADMUX_MUX_GND	0xF0
#define ADMUX_ADLAR	0x20
#define ADMUX_REFS0	0x40
#define ADMUX_REFS1	0x80
#define ADC_MUX_MASK	0x3F


//PRESCALER
#define ADCSRA_ADPS0	0x01
#define ADCSRA_ADPS1	0x02
#define ADCSRA_ADPS2	0x04
#define ADCSRA_ADIE		0x08
#define ADCSRA_ADIF		0x10		//INTERRRUPT FLAG
#define ADCSRA_ADFR		0x20	//FREE RUNNNG SEL
#define ADCSRA_ADSC		0x40	//START  //while (ADCSRA & _BV(ADSC) ) 
#define ADCSRA_ADEN		0x80	//Enable

#define  ADCSRA_PRESCALER_2		0x01
#define  ADCSRA_PRESCALER_4		0x02
#define  ADCSRA_PRESCALER_8		0x03
#define  ADCSRA_PRESCALER_16	0x04
#define  ADCSRA_PRESCALER_32	0x05
#define  ADCSRA_PRESCALER_64	0x06
#define  ADCSRA_PRESCALER_128	0x07
//WERT IN ADCW

#define ADC_X1_CHANNEL	0
#define ADC_X2_CHANNEL	1
#define ADC_Y1_CHANNEL	3
#define ADC_Y2_CHANNEL	4

#define ADC_AUFLOESUNG_8	256
#define ADC_AUFLOESUNG_10	1024


//Entflechtung der Hardware mit Bitzuordungen zu den Relais
//Clear-SECTION 
#define CLEAR_A()	(gu8aTTL74595[0] = 0)								
#define CLEAR_B()	(gu8aTTL74595[1] = 0)
#define CLEAR_C()	(gu8aTTL74595[2] = 0)
#define CLEAR_D()	(gu8aTTL74595[3] = 0)


// *****************************************************


//-------------------------
//PORT B  	//1=OUT
//1=OUT
#define PORTA_OUTMASK	0
#define PORTA_PRESET_PULLMASK 0

#define PORTB_OUTMASK	0

#define PORTB_PRESET_PULLMASK 0

//PORT C 	TWI //1=OUT  0 = IN
//STARTWERTE ADC Port
#define PORTC_OUTMASK (EXT_TTL74595_DIR_REG_BITMSK_SET_SCK_RCK_SCL)
#define PORTC_PRESET_PULLMASK	0

//PORT D	//1=OUT mit UART
#define PORTD_OUTMASK	0
#define PORTD_PRESET_PULLMASK  0

//gu8ProgMode

#endif  //MAIN_HEADER
