

#ifndef TXTFUNC_HEADER
#define TXTFUNC_HEADER

#define UART_USE_ENABLED
#define USE_ERROR_MSG  // schaltet UART Error Behandlung ein

//#define UART_BAUD_RATE	57600
#define UART_BAUD_RATE	38400


#ifdef UART_USE_ENABLED	
#define STRMAX 128
#define NUMMAX 128
#define RX_STRMAX 128
//#define ID_SIZEMAX  1
#define COMAMNDSIZEMAX  128
#define DELIMITER		','
#define DELIMITERSTR	","
#define ASC_CR	13
#define ASC_LF	10

//mechanismus : UART_CMD_EVENT_FLAG lst Handlung aus
#define UART_CMD_EVENT_FLAG	0x01
//gu8UartStatusFlags & UART_CMD_EVENT_FLAG;

// TYPEN DEKLARATION
typedef struct
	{
	char ucaCmd[COMAMNDSIZEMAX +1];
	uint16_t  u16CmdVal_1;
	uint16_t  u16CmdVal_2;
	uint16_t  u16CmdVal_3;
	uint16_t  u16CmdVal_4;
	uint16_t  u16CmdVal_5;
	uint16_t  u16CmdVal_6;
//uint8_t ucCmdID;
	}COMMAND_TYPE;

// GLOBALE VARIABLEN
// const char MCA_DELIMITER_MSG[] PROGMEM	= ",";
extern uint8_t gu8UartStatusFlags;
//extern char* gpcRxPars;
extern char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
extern char gcaNumStr[NUMMAX + 1]; //+1 for the 0
extern char gcaStr[STRMAX + 1]; //+1 for the 0
extern COMMAND_TYPE gsCmd;


// PROTOTYPEN 
//Funktions Deklaration
extern void ResetRxBuff(void);
extern void UART_TXRX_Check(void);
extern void TokensRXStr(char *pcStrOrder); //von gcaRxStr

extern void CheckOrder(void );
extern void LongToNumStr(int32_t lVal);
extern void ULongToNumStr(uint32_t ulVal);
extern void PrintLongCR(int32_t lVal);
extern void PrintULongCR(uint32_t ulVal);
extern void FloatToNumStr(double fVal);
#endif  //UART_USE_ENABLED

#endif // TXTFUNC_HEADER
