

//AT Mega 8
//Diese Version  ist fr 16MHZ QUARZ ausgelegt worden , 
//Siehe makefile F_CPU

/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        30.05.2008
 Description:    Erzeugen eines PAL Video Signals

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 


----------------------------------------------------------------------------*/

#include <avr/interrupt.h>
#include "stdlib.h"
#include <avr/io.h>
#include <math.h>
#include "usart.h"
#include "video.h"

//Cols = 19  ROW=2 = 456
/*
#define CHAR_COLS           19  
   #define CHAR_ROWS           24  

*/
//------------------------------------------------------------------------------
//Hier startet das Hauptprogramm

volatile uint32_t g32TickCounter;
volatile uint32_t g32TickNow;
char gcaNumStr[21];
char gcaStr[81];

const char MCA_ZAHLENREIHE_MSG[] PROGMEM =	"0123456789876543210";
const char MCA_Name_MSG[] PROGMEM =	"Christof Ermer";
const char MCA_ORT_MSG[] PROGMEM =	"Regensburg";

const char MCA_CLEARLINE_MSG[] PROGMEM = 	"                   ";
const char MCA_TICKS_MSG[] PROGMEM = 		"Ticks= ";


// ****************************************************************
uint64_t GetTickDifference(uint32_t u32Time)
// ****************************************************************
{
return (g32TickCounter - u32Time);
};



int main (void) 
{
int32_t i16TT;
// Serielle Schnittstelle initialisieren
//    usart_init(9600); 
//    usart_write("Compiliert am "__DATE__" um "__TIME__"\r\n");
//    usart_write("Compiliert mit GCC Version "__VERSION__"\r\n");
//	for(unsigned long a=0;a<1000000;a++){asm("nop");};
   
  
   
    video_init();
    sei();
    
    video_clear ();
//    video_print (5,5,"TEST");
//    video_print (0,7," ");
    video_print (0,16," ");

    for(unsigned int a = 0;a<255;a++)
    {        
		//screen_buffer[a] = '*';
        //screen_buffer[a] = a;
       screen_buffer[a+168] = a;
    }
  
	
  //Video_print (0,0,"012345678911111111112222");
  strcpy_P(gcaStr, MCA_ZAHLENREIHE_MSG); //Besser
  video_print (0,0,gcaStr); 
  strcpy_P(gcaStr, MCA_Name_MSG); //Besser
  video_print (0,1,gcaStr); 
  strcpy_P(gcaStr, MCA_ORT_MSG); //Besser
  video_print (0,2,gcaStr); 
 
   g32TickNow = g32TickCounter = 0;
    
    while(1)
    {
	

	if( GetTickDifference( g32TickNow ) > 30000UL )
		{
		
		strcpy_P(gcaStr, MCA_CLEARLINE_MSG); 
		video_print(0,2,gcaStr);
	
		strcpy_P(gcaStr, MCA_TICKS_MSG);		
		ultoa(g32TickCounter, gcaNumStr, 10);
		strcat(gcaStr, gcaNumStr);
		video_print(0,3,gcaStr);  
		g32TickNow = 0;
		};
    };
}

