

/*
Christof Ermer
20.03.2018
Neue Version mit getrennten BIT DEfines
02.2015 fr Kurs

NICHT VERGESSEN :
SCL/MR PIN 10  = 1
/OE Pin 13 = 0
*/

#ifndef OUTSHIFT_74_595_HEADER
#define OUTSHIFT_74_595_HEADER

#define TWO_CYCLES() __asm__ __volatile__( "rjmp 1f\n 1:" ) // 2 cycles

// !!!!!!!!!!!!!!!!!!!! 
#define USED_74595_ICS	2 //ANPASSEN AN CHIP-ZAHL, bzw + bertrag
// !!!!!!!!!!!!!!!!!!!! 

#define OS74595_DS_PORT    PORTD 	//DATA
#define OS74595_DS_DDRX    DDRD
#define OS74595_DS_PIN_NR		3

#define OS74595_SH_CP_PORT  PORTD //SCK
#define OS74595_SH_CP_DDRX  DDRD
#define OS74595_SH_CP_PIN_NR	4

#define OS74595_ST_CP_PORT	PORTC	//RCK
#define OS74595_ST_CP_DDRX	DDRC
#define OS74595_ST_CP_PIN_NR	4 

//PINS
#define DS_74595     (1<< OS74595_DS_PIN_NR  ) 	 // DATA
#define SH_CP_74595  (1<< OS74595_SH_CP_PIN_NR ) //SCK
#define ST_CP_74595  (1<<  OS74595_ST_CP_PIN_NR )  // Store / RCK
// !!!!!!!!!!!!!!!!!!!! 


#define OUT_74595_SERDATA_LOW()		(OS74595_DS_PORT &= ~DS_74595 ) //Daten rausshiften
#define OUT_74595_SERDATA_HIGH()	(OS74595_DS_PORT |= DS_74595 ) //Daten rausshiften

#define OUT_74595_SCK_LOW()		(OS74595_SH_CP_PORT &= ~SH_CP_74595 ) //Shift clock
#define OUT_74595_SCK_HIGH()	(OS74595_SH_CP_PORT |= SH_CP_74595 ) //Shift clock

#define OUT_74595_RCK_LOW()		(OS74595_ST_CP_PORT &= ~ST_CP_74595 ) //Latch Data to Output
#define OUT_74595_RCK_HIGH()	(OS74595_ST_CP_PORT |= ST_CP_74595 ) // Latch Data to Output


//POINTERdes Datentyps der Funktion ebenfalls anpassen
//extern void OUT_74595( uint32_t *p1_X_OutVal ) ;
extern void OUT_74595_InitDDRegs(void);
extern void OUT_74595( uint32_t u32Val ) ;

#endif //OUTSHIFT_74_595_HEADER
