
//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------
#define SOFTWARE	"Debounce"
#define HARDWARE	"Arduino-UNO ATMega328"
#define DATUM		"17.03.2017 12:00"
#define AUTOR		"=/\= Christof Ermer =/\= "
#define IHAVENOBRAIN	"I have no brain"	
#define USEYOURS		"Use your own"

#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>


#define  KEY_RELEASED		0x01
#define  KEY_RELEASE_DETECT	0x02
#define  KEY_PRESSED		0x04
#define  KEY_PRESSED_DETECT	0x08
#define  KEY_VALIDE			0x10
#define  KEY_INT_EVENT		0x20

uint8_t gu8SWSatus;

#define KEY_DDRX	DDRB
#define KEY_PORTX	PORTB
#define KEY_PINX	PINB
#define KEY_1		(1<<0)

#define KEY_INIT()	( KEY_DDRX &= ~KEY_1 )
#define KEY_CLEARPULLUP	( PORTB &= ~KEY_1 )
#define READ_KEY1()  ( KEY_PINX & KEY_1 )






// ***************
int main(void)
// ***************
{


void CheckKey(void)
{
uint8_t u8LocKey;
uint8_t u8NN=0;
do
	{
	u8LocKey = (PINB & (1<<0));
	_delay_us(50);	
	
	if( u8LocKey !=  READ_KEY1() )  
		{
		u8NN=0;		 
		gu8SWSatus |= KEY_PRESSED_DETECT;
		}
	u8NN++;	
	}while(u8NN < 3);

gu8SWSatus = KEY_PRESSED;

if(  READ_KEY1() && !(gu8SWSatus & KEY_RELEASE_DETECT)	) //Taste nicht gedrckt
	{
	u8NN = 0;
	u8LocKey = READ_KEY1();
	gu8SWSatus |= KEY_RELEASE_DETECT;
	};
	

while( (gu8SWSatus & KEY_RELEASE_DETECT ) && 
	!(gu8SWSatus & KEY_RELEASED) &&	
	READ_KEY1()	
) 
	{
		if( READ_KEY1() )  
		{
		if( u8NN < 240 )
			{
			u8NN++;	
			_delay_us(50);	
			}
		else
			{
			gu8SWSatus = KEY_RELEASED;		
			};
		}
	
	};

};
	
	
	
while( 1 )
	{	
	//if( !READ_KEY1()  )
	//if( !(KEY_PINX & KEY_1)   )
	CheckKey();		
	
	if( !READ_KEY1() )  //NOT   
		{
		if( gu8SWSatus & KEY_RELEASED )
			{
			//gu8SWSatus & ~KEY_RELEASED;
			gu8SWSatus = 0;
			gu8SWSatus |= KEY_PRESSED_DETECT;
			CheckKey();			
			};
		};
	
	if(gu8SWSatus & KEY_PRESSED)
		{
		//DO Job
		}

	_delay_ms(1);
	};
	
};	//main
// *** MAIN END ***
