
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

//#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <util\delay.h>
//#include <avr\eeprom.h>	
//#include <avr\twi.h>
//#include <avr\signal.h> //#include <signal.h>
//#include "74595.h"
#include "74595_extern.h"

uint8_t gu8aExt_TTL74595[ EXT_NUMBER_OF_74595 ];//Gobales Array mit Bytezahl der benutzen Shiftregister

// *******************************************************************
void Ext_Write_OUT74HC595( uint8_t * pcaExt74HC595 )  // mit pointer auf array
// *******************************************************************
{
uint8_t u8NN;
uint8_t u8AA; // 74595 Cnt

cli(); //immmer wieder Auf A0..D0 die Relais aktiviert 
EXT_TTL74595_SCK_LOW();
EXT_TTL74595_SCL_LOW(); // /Shift Clear Diese Leitung Knnte auch immer High sein.
_delay_us(1);
EXT_TTL74595_SCL_HIGH();
_delay_us(1);
u8AA = EXT_NUMBER_OF_74595 -1;
do
	{
	u8NN = 7;
	do
		{  // Clock out bits from the eo array
		 if( pcaExt74HC595[u8AA] & (1UL << u8NN) ) 	// Ist es undiert eine EINS ?
			{	 
			Ext_TTL74595_SERDATA_HIGH();     
			}		 
		 else
			{	
			Ext_TTL74595_SERDATA_LOW();	
			};
		_delay_us(1);
		EXT_TTL74595_SCK_HIGH();	//Shift clock
		_delay_us(1);
		EXT_TTL74595_SCK_LOW(); //Shift clock
	  }while( u8NN-- );//NUMBER_OF_74595
	}while(u8AA--);  
EXT_TTL74595_RCK_HIGH(); // Latch Data to Output
_delay_us(1);
EXT_TTL74595_RCK_LOW();
sei();
};
