
#include <avr\io.h>
 #include <stdint.h> 
#include <inttypes.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms

#include "In74165.h"

//Remember #define _BV(	bit )	(1 << (bit))
//Integer types capable of holding object pointers

/*
// ******************************************
void Toggle_74165_CLK( void )
// ******************************************
{
SET_74165_CLK();
_delay_us(1);
CLR_74165_CLK();
_delay_us(1);
};
*/


// ******************************************
uint64_t ScanInShift74165( void )
// ******************************************
{
uint8_t u8NN;
uint64_t g64InShift;	//ULL zur AUfnahme des Ergebnisses

CLR_74165_CLK()	
CLR_74165_SHLD()
_delay_us(1);
SET_74165_SHLD();

g64InShift = 0;
for(u8NN=0; u8NN < (CHIP_COUNT_74165_MAX * 8); u8NN++)
	{
	_delay_us(2);
	if( Read_QH() )	//wenn 1
		{		
		g64InShift |= (uint64_t)( 1ULL << u8NN );
		};
	SET_74165_CLK();
	_delay_us(2);
	CLR_74165_CLK();
	};		
return g64InShift;
};

