

#ifndef IN74165_HEADER
#define IN74165_HEADER

#define IN74165_USED

#define INSHIFT_74165_PORT	PORTA
#define INSHIFT_74165_PIN	PINA
#define INSHIFT_74165_DDRX	DDRA
#define INSHIFT_74165_DDRX_VALUES	0b10001000	

#define CHIP_COUNT_74165_MAX	5	// Zahl  Der Shift Chips
#define INSHIFT_74165_CLK_BIT	0x80	
#define INSHIFT_74165_SHLD		0x08	//	SH /LD
//#define INSHIFT_74165_SER		
//#define INSHIFT_74165_INH
#define INSHIFT_74165_QH_BIT	0x40	//	QH  Input
//#define INSHIFT_74165__QH	//	/QH




//MAKROS
#define INIT_74165PORTDIR()	(INSHIFT_74165_DDRX = INSHIFT_74165_DDRX_VALUES);

#define SET_74165_CLK()	(INSHIFT_74165_PORT |= INSHIFT_74165_CLK_BIT);
#define CLR_74165_CLK()	(INSHIFT_74165_PORT &= ~INSHIFT_74165_CLK_BIT);

#define SET_74165_SHLD()	(INSHIFT_74165_PORT |= INSHIFT_74165_SHLD);
#define CLR_74165_SHLD()	(INSHIFT_74165_PORT &= ~INSHIFT_74165_SHLD);

#define Read_QH() 	(INSHIFT_74165_PIN & INSHIFT_74165_QH_BIT)

//extern uint8_t u8aInShift[ CHIP_COUNT_74165_MAX ];	//ARRAY
extern uint64_t ScanInShift74165( void );		
//typedef unsigned long long int 	uint64_t



#endif //IN74165_HEADER
