/MAX110 SECTION
#define MAX_PORT				PORTA
#define MAXPORT_DIRECTION_MASK	0x0B  //=  000 01011
#define MAX_CS_BIT_O			PA0	//OUT
#define MAX_SCKL_BIT_O		PA1	//OUT
#define MAX_BUSY_BIT_I		PA2	//IN  
#define MAX_DOUT_BIT_O		PA3	//OUT
#define MAX_DIN_BIT_I		PA4	//IN

#define MAX_DOUT_MASK			(_BV(MAX_DOUT_BIT_O))
#define MAX_DIN_MASK			(_BV(MAX_DIN_BIT_O))
#define MAX_BUSY_MASK			(_BV(MAX_BUSY_BIT_I))


#define MAX_CS_HIGH_MAC		sbi(MAX_PORT, MAX_CS_BIT_O);
#define MAX_CS_LOW_MAC		cbi(MAX_PORT, MAX_CS_BIT_O);
#define MAX_SCKL_HIGH_MAC	sbi(MAX_PORT, MAX_SCKL_BIT_O);
#define MAX_SCKL_LOW_MAC	cbi(MAX_PORT, MAX_SCKL_BIT_O);
